-- 钓鱼-自动时委托
Lua_GoFishingContractsWindow = class("Lua_GoFishingContractsWindow", Lua_Window);
function Lua_GoFishingContractsWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_GoFishingContractsWindow";
	self.skinName = "GoFishingContractsWindow_skin";
	self.layer = MainWinDefine.NORMAL_TOP_LAYER;
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_GoFishingContractsWindow:buildShowItem()
	self:superCall("buildShowItem");

	if DataCenter.goFishingController.isAuto then
		self.sureBtn:setLangValue(794053);
	else
		self.sureBtn:setLangValue(794054);
	end

	self.qualityBox.selected = DataCenter.goFishingController.isCheckQuality;
	self.newRecordBox.selected = DataCenter.goFishingController.isCheckNewRecord;
	self.newAtlasBox.selected = DataCenter.goFishingController.isCheckNewAtlas;
	self.qualityBg_2.clickScale = false;
	self.listMaskBtn.clickScale = false;
	self.listMaskBtn:setEnable(false);
	self.qualityBox:addBoxChange(self, self.onQualityBoxChange);
	self.newRecordBox:addBoxChange(self, self.onNewRecordBoxChange);
	self.newAtlasBox:addBoxChange(self, self.onNewAtlasBoxChange);
	self.sureBtn:addClickFuntion(self, self.onSureClick);
	self.qualityBg_2:addClickFuntion(self, self.onQualityClick);
	self.listMaskBtn:addClickFuntion(self, self.onListMaskClick);

	self:updateQualityInfo(DataCenter.goFishingController.quality);
	self:addLuaEvent("ON_GOFISHING_CONTRACTS_ITEM_CLICK", self, self.updateQualityInfo);
end

function Lua_GoFishingContractsWindow:updateQualityInfo(param)
	self.listMaskBtn:setEnable(false);
	if self.qualityList ~= nil then
		self.qualityList:setEnable(false);
	end
	DataCenter.goFishingController.quality = param
	self.qualityTxt.text = DataCenter.goFishingUtil:getTheQualityName(DataCenter.goFishingController.quality);
end

function Lua_GoFishingContractsWindow:onQualityBoxChange(val)
	DataCenter.goFishingController.isCheckQuality = val;
end

function Lua_GoFishingContractsWindow:onNewRecordBoxChange(val)
	DataCenter.goFishingController.isCheckNewRecord = val;
end

function Lua_GoFishingContractsWindow:onNewAtlasBoxChange(val)
	DataCenter.goFishingController.isCheckNewAtlas = val;
end

function Lua_GoFishingContractsWindow:onSureClick(go)
	if not DataCenter.goFishingController.isAuto and DataCenter.goFishingController.isFishing then
		OperateAlert.showLangValue(794083);
		return;
	end

	if DataCenter.goFishingData.gofishingOpenTime <= 0 then -- 非活动时间
		OperateAlert.showLangValue(794055);
	else
		local hasCount = DataCenter.packData:getItemCountById(Lua_ResourcesDefine.GOFISHING_STAMINA);
		if hasCount <= 0 then -- 体力不足
			OperateAlert.showLangValue(794056);
		else
			if DataCenter.goFishingController.isAuto then
				DataCenter.goFishingController.isAuto = false;
			else
				DataCenter.goFishingController.isAuto = true;
				DataCenter.goFishingController:checkAutoHandel(1)
			end
		end
	end
	self:hide();
end

function Lua_GoFishingContractsWindow:onQualityClick(go)
	self.listMaskBtn:setEnable(true);
	if self.qualityList == nil then
		self.qualityList = Lua_DragList.new(self.content, 186, 215, Lua_AxisDefine.Vertical);
		self.qualityList.canDrag = false;
		self.qualityList:setListCell(Lua_GoFishingContractsItem, 186, 43, 1);
		self.qualityList:setLocation(193, -41, 0);
	end
	local arr = Array();
	for i = 2, 6 do
		arr:add(i);
	end
	self.qualityList:setArrayData(arr);
	self.qualityList:setEnable(true);
end

function Lua_GoFishingContractsWindow:onListMaskClick(go)
	self.listMaskBtn:setEnable(false);
	if self.qualityList ~= nil then
		self.qualityList:setEnable(false);
	end
end

function Lua_GoFishingContractsWindow:dispose()
	if self.qualityList ~= nil then
		self.qualityList:dispose();
		self.qualityList = nil;
	end
	self:superCall("dispose");
end










Lua_GoFishingContractsItem = class("Lua_GoFishingContractsItem", Lua_ListCell);
function Lua_GoFishingContractsItem:ctor(p)
	self:superCall("ctor", p, "GoFishingContractsItem_skin");
end

function Lua_GoFishingContractsItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_GoFishingContractsItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end
	self.qualityTxt.text = DataCenter.goFishingUtil:getTheQualityName(data);
end

function Lua_GoFishingContractsItem:onPressClick()
	if self._data then
		Lua_MsgUtil.callFunc("ON_GOFISHING_CONTRACTS_ITEM_CLICK", self._data);
	end
end

function Lua_GoFishingContractsItem:dispose()
	self:superCall("dispose");
end