-- 钓鱼-每日礼包界面
Lua_GoFishingDailyGiftWindow = class("Lua_GoFishingDailyGiftWindow", Lua_Window);
function Lua_GoFishingDailyGiftWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_GoFishingDailyGiftWindow";
	self.skinName = "GoFishingDailyGiftWindow_skin";
	self.layer = MainWinDefine.NORMAL_TOP_LAYER;
	self.isFullSizeWin = true;
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_GoFishingDailyGiftWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.giftList = Lua_DragList.new(self.content, 629, 606, Lua_AxisDefine.Vertical);
	self.giftList:setListCell(Lua_GoFishingDailyGiftItem, 629, 166, 1);
	self.giftList:setCellSpacing(0, 6);
	self.giftList:setLocation(0, -152, 0);

	self:addLuaEvent("UPDATE_GOFISHING_DAILYGIFT_INFO", self, self.updateDailyGiftInfo);
	Lua_ProxyManager.getProxy("Lua_GoFishingProxy"):sGoFishingDailyGiftInfo();
end

function Lua_GoFishingDailyGiftWindow:updateDailyGiftInfo(msg)
	-- 可领取＞未达成＞已领取，info1：0未完成 1可领取 2已领取
	table.sort( msg.reward_state,
		function(a, b)
			if a.value > 0 or b.value > 0 then
				if a.value > 0 and b.value > 0 then
					return a.key < b.key;
				else
					return a.value > 0;
				end
			else
				return a.key < b.key;
			end
		end
	);
	self.giftList:setArrayData(msg.reward_state);
end

function Lua_GoFishingDailyGiftWindow:dispose()
	if self.giftList ~= nil then
		self.giftList:dispose();
		self.giftList = nil;
	end
	self:superCall("dispose");
end










Lua_GoFishingDailyGiftItem = class("Lua_GoFishingDailyGiftItem", Lua_ListCell);
function Lua_GoFishingDailyGiftItem:ctor(p)
	self:superCall("ctor", p, "GoFishingDailyGiftItem_skin");
end

function Lua_GoFishingDailyGiftItem:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardList = Lua_DragList.new(self.content, 370, 87, Lua_AxisDefine.Horizontal);
	self.rewardList:setListCell(Lua_GoFishingDailyGiftRewardItem, 87, 87, 1);
	self.rewardList:setCellSpacing(13, 0);
	self.rewardList:setRectPivot(3);
	self.rewardList:setLocation(-280, -13);
	self:setSubList(self.rewardList);

	self.buyBtn:addClickFuntion(self, self.onBuyClick);
end

function Lua_GoFishingDailyGiftItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	self.giftInfo = DataCenter.goFishingUtil:getFishDailyGiftInfo(data.key);
	self.titleTxt.text = self.giftInfo.name;
	self.timesTxt.text = LanUtil.formateStr(794057, data.value, self.giftInfo.daily_times);

	self.rewardList.canDrag = #self.giftInfo.reward_item > 4;
	self.rewardList:setArrayData(self.giftInfo.reward_item);

	if data.value <= 0 then
		self.buyBtn:setLangValue(794058);
	else
		if self.giftInfo.cost_item then
			if self.giftInfo.cost_item[2] <= 0 then
				self.buyBtn:setLangValue(794059);
			else
				self.buyBtn.label = LanUtil.formateStr(794060, spliceIconStrById(self.giftInfo.cost_item[1]), self.giftInfo.cost_item[2]);
			end
		else
			local rechargeInfo = Lua_RechargeConfigData.getRechargeConfig(data.key);
			self.buyBtn.label = LanUtil.formateStr(794061, tonumber(rechargeInfo.money));
		end
	end
	self.buyBtn:setBtnEnable(data.value > 0);
	self:showRedDot(self.giftInfo.cost_item and self.giftInfo.cost_item[2] <= 0 and data.value > 0);
end

function Lua_GoFishingDailyGiftItem:showRedDot(bShow)
	if bShow == true then
		if self.redPoint == nil then
			self.redPoint = Lua_RedPointIcon.new(self.content);
			self.redPoint:createRedPointEff();
			self.redPoint:setLocation(280, -2, 0);
		end
		self.redPoint:updateRedPointShow(true);
	else
		if self.redPoint ~= nil then
			self.redPoint:updateRedPointShow(false);
		end
	end
end

function Lua_GoFishingDailyGiftItem:onBuyClick(go)
	if self.giftInfo.cost_item then
		Lua_ProxyManager.getProxy("Lua_GoFishingProxy"):sBuyGoFishingDailyGift(self._data.key);
	else
		local rechargeInfo = Lua_RechargeConfigData.getRechargeConfig(self._data.key);
		DataCenter.sdkInterface:PointOut(1, tonumber(rechargeInfo.money), tonumber(rechargeInfo.money_type),
			tonumber(rechargeInfo.id), rechargeInfo.gift_name, rechargeInfo.gold);
	end
end

function Lua_GoFishingDailyGiftItem:dispose()
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	if self.redPoint ~= nil then
		self.redPoint:dispose();
		self.redPoint = nil;
	end
	self._data = nil;
	self.giftInfo = nil;
	self:superCall("dispose");
end










Lua_GoFishingDailyGiftRewardItem = class("Lua_GoFishingDailyGiftRewardItem", Lua_ItemIconCell);
function Lua_GoFishingDailyGiftRewardItem:buildShowItem()
	self:superCall("buildShowItem");
	self.itemIcon:setScale(0.7, 0.7);
end