-- 钓鱼-每日订单
Lua_GoFishingDailyIndentWindow = class("Lua_GoFishingDailyIndentWindow", Lua_Window);
function Lua_GoFishingDailyIndentWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_GoFishingDailyIndentWindow";
	self.skinName = "GoFishingDailyIndentWindow_skin";
	self.layer = MainWinDefine.NORMAL_TOP_LAYER;
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_GoFishingDailyIndentWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.multipleIcon:setEnable(DataCenter.goFishingData.activeUp > 1);

	local indentMoneyItem = DataCenter.goFishingUtil.indentMoneyItem;
	local item;
	self.moneyItemArr = Array();
	for i = 1, #indentMoneyItem do
		item = Lua_MoneyItem.new(self.content);
		item:setCanClick(true);
		item:setLocation(-408 + i * 190, 197, 0);
		item:setMoney(indentMoneyItem[i]);
		self.moneyItemArr:add(item);
	end

	local resetItem = DataCenter.goFishingUtil.resetItem;
	local hasCount = DataCenter.packData:getItemCountById(resetItem[1]);
	local colorStr = hasCount >= resetItem[2] and "726763" or "E54242";
	self.costTxt.text = LanUtil.formateStr("{1}<color=#{2}>{3}</color>", spliceIconStrById(resetItem[1]), colorStr, resetItem[2]);

	self.indentList = Lua_DragList.new(self.content, 629, 520, Lua_AxisDefine.Vertical);
	self.indentList:setListCell(Lua_GoFishingDailyIndentItem, 629, 210, 1);
	self.indentList:setCellSpacing(0, 6);
	self.indentList:setLocation(0, -109, 0);

	self.resetBtn:addClickFuntion(self, self.onReSetClick);

	self:updateDailyIndentInfo();
	self:addLuaEvent("UPDATE_GOFISHING_INDENT_INFO", self, self.updateDailyIndentInfo);
end

function Lua_GoFishingDailyIndentWindow:updateDailyIndentInfo()
	self.indentList:setArrayData(DataCenter.goFishingData.fishingIndentList);
end

function Lua_GoFishingDailyIndentWindow:onReSetClick(go)
	local isComplete = true;
	local indentList = DataCenter.goFishingData.fishingIndentList;
	for i = 1, #indentList do
		if indentList[i].draw_state ~= 2 then
			isComplete = false;
			break;
		end
	end
	if isComplete then -- 完成
		local resetItem = DataCenter.goFishingUtil.resetItem;
		local hasCount = DataCenter.packData:getItemCountById(resetItem[1]);
		if hasCount >= resetItem[2] then
			Lua_ProxyManager.getProxy("Lua_GoFishingProxy"):sResetGoFishingIndentInfo();
		else
			DataCenter.packUtil:openPathWindow(resetItem[1]);
		end
	else
		OperateAlert.showLangValue(794062);
	end
end

function Lua_GoFishingDailyIndentWindow:dispose()
	if self.moneyItemArr ~= nil then
		self.moneyItemArr:dispose();
		self.moneyItemArr:clear();
		self.moneyItemArr = nil;
	end
	if self.indentList ~= nil then
		self.indentList:dispose();
		self.indentList = nil;
	end
	self:superCall("dispose");
end










Lua_GoFishingDailyIndentItem = class("Lua_GoFishingDailyIndentItem", Lua_ListCell);
function Lua_GoFishingDailyIndentItem:ctor(p)
	self:superCall("ctor", p, "GoFishingDailyIndentItem_skin");
end

function Lua_GoFishingDailyIndentItem:buildShowItem()
	self:superCall("buildShowItem");

	self.showStarArr = Array();

	self.rewardList = Lua_DragList.new(self.content, 370, 100, Lua_AxisDefine.Horizontal);
	self.rewardList:setListCell(Lua_GoFishingDailyIndentRewardItem, 100, 100, 1);
	self.rewardList:setCellSpacing(12, 0);
	self.rewardList:setRectPivot(3);
	self.rewardList:setLocation(-280, -40);
	self:setSubList(self.rewardList);

	self.refreshBtn:addClickFuntion(self, self.onRefreshClick);
	self.stateBtn:addClickFuntion(self, self.onStateClick);
end

function Lua_GoFishingDailyIndentItem:setData(data)
	self._data = data;
	local config = DataCenter.goFishingUtil:getFishTaskInfo(data.task_id);
	if data == nil or config == nil then
		return;
	end

	self.titleTxt.text = config.indent_name;
	self.condTxt.text = config.name;
	local star = config.star or 0;
	local sprite = star <= 1 and "xui_cdzj_quality_2" or "xui_cdzj_quality_" .. star;
	self.titleBg:setAltas("gofishing_atlas_2", sprite);

	self.progressBar:setMaxValue(config.process);
	self.progressBar:setValue(data.process);
	self.progressBar:setText(data.process .. "/" .. config.process);

	local list = config.reward;
	self.rewardList.canDrag = #list > 3;
	self.rewardList:setArrayData(list);

	if data.draw_state == 0 then -- 未达成
		self.stateBtn:setLangValue(794063);
	elseif data.draw_state == 1 then -- 可领取
		self.stateBtn:setLangValue(794064);
	else -- 已领取
		self.stateBtn:setLangValue(794065);
	end
	self.stateBtn:setBtnEnable(data.draw_state == 1);
	-- self:showStarFun(star);
	self:showRedDot(data.draw_state == 1);
end

function Lua_GoFishingDailyIndentItem:showStarFun(actualStar)
	local showStar = actualStar > 5 and actualStar - 5 or actualStar;
	local arrLen = self.showStarArr:getSize();
	local starIcon;
	for i = 1, 5 do
		starIcon = self.showStarArr[i];
		if starIcon == nil then
			starIcon = UICreate.createUIAtlasImage(self.content, nil, nil, 0, 0, 0, 0);
			self.showStarArr:add(starIcon);
		end
		starIcon:setGray(i > showStar);
		starIcon:setEnable(true);
		starIcon:setLocation(140 + (i - 1) * 23, 90, 0);
		if 5 >= actualStar then
			starIcon:setAltas("common_altas_1", "xui_common_label_09");
		else
			starIcon:setAltas("common_altas_1", "xui_common_label_10");
		end
	end
end

function Lua_GoFishingDailyIndentItem:showRedDot(bShow)
	if bShow == true then
		if self.redPoint == nil then
			self.redPoint = Lua_RedPointIcon.new(self.content);
			self.redPoint:setLocation(263, -18, 0);
			self.redPoint:createRedPointEff();
		end
		self.redPoint:updateRedPointShow(true);
	else
		if self.redPoint ~= nil then
			self.redPoint:updateRedPointShow(false);
		end
	end
end

function Lua_GoFishingDailyIndentItem:onRefreshClick(go)
	if self._data.draw_state == 2 then
		OperateAlert.showLangValue(794066);
	else
		local refreshItem = DataCenter.goFishingUtil.refreshItem;
		local hasCount = DataCenter.packData:getItemCountById(refreshItem[1]);
		if hasCount >= refreshItem[2] then
			Lua_ProxyManager.getProxy("Lua_GoFishingProxy"):sRefreshGoFishingIndentInfo(self._data.sort_id);
		else
			DataCenter.packUtil:openPathWindow(refreshItem[1]);
		end
	end
end

function Lua_GoFishingDailyIndentItem:onStateClick(go)
	if self._data.draw_state == 1 then
		Lua_ProxyManager.getProxy("Lua_GoFishingProxy"):sCompleteIndent(self._data.sort_id);
	end
end

function Lua_GoFishingDailyIndentItem:dispose()
	if self.showStarArr ~= nil then
		self.showStarArr:dispose();
		self.showStarArr:clear();
		self.showStarArr = nil;
	end
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	if self.redPoint ~= nil then
		self.redPoint:dispose();
		self.redPoint = nil;
	end
	self._data = nil;
	self:superCall("dispose");
end










Lua_GoFishingDailyIndentRewardItem = class("Lua_GoFishingDailyIndentRewardItem", Lua_ItemIconCell);
function Lua_GoFishingDailyIndentRewardItem:buildShowItem()
	self:superCall("buildShowItem");
	self.itemIcon:setScale(0.8, 0.8);
end