-- 钓鱼-入口
Lua_GoFishingEntranceWindow = class("Lua_GoFishingEntranceWindow", Lua_Window);
function Lua_GoFishingEntranceWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_GoFishingEntranceWindow";
	self.skinName = "GoFishingEntranceWindow_skin";
	self.layer = MainWinDefine.MAIN_MENU_TOP_LAYER;
	self.blackAlpha = 0.8;
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_GoFishingEntranceWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.openTimeTxt:setLangValue(794091);

	local firstPlayer = DataCenter.goFishingData.firstPlayer;
	if firstPlayer.id == nil or tonumber(firstPlayer.id) == 0 then
		self.perFirstObj:SetActive(false);
	else
		self.perFirstObj:SetActive(true);

		self.avatarItem = Lua_AvatarItem.new(self.content);
		self.avatarItem:setScale(0.7, 0.7, 0.7);
		self.avatarItem:setLocation(-89, 59, 0);
		self.avatarItem:setRoleId(firstPlayer.id);
		self.avatarItem:setRoleDressUp(firstPlayer.dress_info, true);
		self.avatarItem:setRoleLevel2(firstPlayer.level);

		local firstFish = DataCenter.goFishingData.firstFish;
		local config = getConfig("item", firstFish.fishing);
		-- self.desTxt_2.text = config.name;
		self.nameTxt.text = firstPlayer.name;

		local tvo = Lua_ToolVo.createToolVo(firstFish.fishing);
		local showLength = tvo.max_length > tvo.length * firstFish.length and tvo.length * firstFish.length or tvo.max_length;
		self.lengthTxt.text = string.format("%.2f%s", showLength, "cm");
	end

	self.endTime = DataCenter.goFishingData.gofishingOpenTime;
	-- self.endTime = getReaminSecondsTo24();
	self:startTimer();
	self:updateLeftTime();

	self.gotoBtn:addClickFuntion(self, self.onGotoClick);
end

function Lua_GoFishingEntranceWindow:startTimer()
	if self.countDown ~= true then
		self.countDown = true;
		self:addTimer("Lua_GoFishingEntranceWindow", 1, self, self.updateLeftTime);
	end
end

function Lua_GoFishingEntranceWindow:updateLeftTime()
	self.endTime = self.endTime - 1;
	self.leftTimeTxt.text = LanUtil.formateStr(794068, Lua_TimeTransform.transSeconds6(self.endTime, true, true, true));
	if self.endTime <= 0 then
		self:endTimer();
	end
end

function Lua_GoFishingEntranceWindow:endTimer()
	if self.countDown == true then
		self.countDown = false;
		self:removeTimer(self, self.updateLeftTime);
	end
end

function Lua_GoFishingEntranceWindow:onGotoClick(go)
	DataCenter.funcPathUtil:gotoFunction(1190, true);
end

function Lua_GoFishingEntranceWindow:dispose()
	if self.avatarItem ~= nil then
		self.avatarItem:dispose();
		self.avatarItem = nil;
	end
	self:endTimer();
	self:superCall("dispose");
end