-- 钓鱼-获得界面
Lua_GoFishingGetResultWindow = class("Lua_GoFishingGetResultWindow", Lua_Window);
function Lua_GoFishingGetResultWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_GoFishingGetResultWindow";
	self.skinName = "GoFishingGetResultWindow_skin";
	self.layer = MainWinDefine.NORMAL_TOP_LAYER;
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_GoFishingGetResultWindow:buildShowItem()
	self:superCall("buildShowItem");

	local getFish = DataCenter.goFishingData.getFish;
	local tvo = Lua_ToolVo.createToolVo(getFish.fishing);
	local percent, price, iconInfo;
	if tvo.sub_type == Lua_PackDefine.GOFISHING_RUBBISH then -- 杂物
		percent = DataCenter.goFishingData:getTheFishAttrValue("fish_sweeper");
		price = Mathf.Floor((tvo.sys_price * (1 + percent * DataCenter.goFishingData.activeUp)) + 0.5); -- 四舍五入
		iconInfo = spliceIconStrById(tvo.money_id);
	elseif tvo.sub_type == Lua_PackDefine.GOFISHING_COLLECTION then -- 藏品
		price = 0;
		iconInfo = nil;
	else -- 鱼/水中生物
		percent = DataCenter.goFishingData:getTheFishAttrValue("fish_fisher");
		price = Mathf.Floor((tvo.sys_price * (1 + percent * DataCenter.goFishingData.activeUp)) + 0.5); -- 四舍五入
		iconInfo = spliceIconStrById(tvo.money_id);

		local attrDic = {};
		for k,v in pairs(tvo.add_prop) do
			attrDic[k] = v * getFish.length;
		end
		local attrArr = DataCenter.attributesUtil:getAttrArrByDic(attrDic);
		self.fishPropList = Lua_DragList.new(self.content, 654, 110, Lua_AxisDefine.Vertical);
		self.fishPropList.canDrag = attrArr:getSize() > 2;
		self.fishPropList:setListCell(Lua_GoFishingGetResultItem, 654, 46, 1);
		self.fishPropList:setCellSpacing(0, 5);
		self.fishPropList:setLocation(0, -314, 0);
		self.fishPropList:setArrayData(attrArr);
	end
	self.nameTxt.text = tvo.colorName;
	self.desTxt.text = tvo.des;
	local showLength = tvo.max_length > tvo.length * getFish.length and tvo.length * getFish.length or tvo.max_length;
	self.lengthTxt.text = string.format("%.2f%s", showLength, "cm");
	self.lengthTxt:setEnable(showLength > 0);
	self.costTxt.text = LanUtil.formateStr("{1}{2}", iconInfo, price);
	self.typeIcon:setAltas("gofishing_atlas_2", "xui_cdzj_label_00" .. tvo.sub_type);

	local fishingIndentList = DataCenter.goFishingData.fishingIndentList;
	local indentLangId = 794069;
	local sureLangId = 794070;
	self.operateType = 0;
	for i = 1, #fishingIndentList do
		taskInfo = DataCenter.goFishingUtil:getFishTaskInfo(fishingIndentList[i].task_id);
		if taskInfo then
			if tvo.sub_type == Lua_PackDefine.GOFISHING_RUBBISH then -- 杂物
				if taskInfo.temp and (tvo.id == taskInfo.temp or tvo.sub_type == taskInfo.temp) and taskInfo.process > fishingIndentList[i].process then
					self.operateType = 1;
					sureLangId = 794071;
					break;
				else
					self.operateType = 2;
					sureLangId = 794069;
				end
			elseif tvo.sub_type == Lua_PackDefine.GOFISHING_COLLECTION then -- 藏品/放入背包
				self.operateType = 3;
				sureLangId = 794072;
				break;
			elseif taskInfo.temp and (tvo.id == taskInfo.temp or tvo.sub_type == taskInfo.temp or (taskInfo.task_type == 5 and tvo.color >= taskInfo.temp)) then -- 鱼、水中生物
					if taskInfo.process > fishingIndentList[i].process then
						self.operateType = 4;
						indentLangId = 794071;
						sureLangId = 794070;
						break;
					else
						self.operateType = 0;
						indentLangId = 794069;
						sureLangId = 794070;
						break;
					end
			end
		end
	end

	local posX = (self.operateType == 0 or self.operateType == 4) and 150 or 0;
	self.sureBtn:setLocation(posX, -420, 0);
	posX = self.operateType == 0 and -150 or 0;
	self.costTxt:setLocation(posX, -475, 0);
	self.indentBtn:setLangValue(indentLangId);
	self.sureBtn:setLangValue(sureLangId);
	self.costTxt:setEnable(self.operateType == 0 or self.operateType == 2);
	self.newGetIcon:setEnable(tvo.sub_type ~= Lua_PackDefine.GOFISHING_RUBBISH and getFish.is_new == 2);
	self.newRecordIcon:setEnable(tvo.sub_type ~= Lua_PackDefine.GOFISHING_RUBBISH and tvo.sub_type ~= Lua_PackDefine.GOFISHING_COLLECTION and getFish.is_new == 1 or getFish.is_new == 2);
	self.indentBtn:setEnable(self.operateType == 0 or self.operateType == 4);

	self.indentBtn:addClickFuntion(self, self.onIndentClick);
	self.sureBtn:addClickFuntion(self, self.onSureClick);
end

function Lua_GoFishingGetResultWindow:onIndentClick(go)
	local getFish = DataCenter.goFishingData.getFish;
	if self.operateType == 0 then -- 出售
		self:onSellFun();
	else -- 提交订单，有指定杂物和同种类型杂物两种情况
		Lua_ProxyManager.getProxy("Lua_GoFishingProxy"):sDealWithFish(getFish.unique_id, 2, 0);
		self:hide();
	end
end

function Lua_GoFishingGetResultWindow:onSellFun()
	local tvo = Lua_ToolVo.createToolVo(DataCenter.goFishingData.getFish.fishing);
	if tvo.color > 4 and not DataCenter.neverTipData:getNeverValue(Lua_NeverTipDefine.GOFISHING_SELL) and tvo.sub_type ~= Lua_PackDefine.GOFISHING_RUBBISH then
		local tipsData = {
			des = 794007,
			posY = 50,
			btnType = 1,
			neverTip = Lua_NeverTipDefine.GOFISHING_SELL,
			owner = self,
			sureFun = self.onSureSellFun
		};
		Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
	else
		self:onSureSellFun();
	end
end

function Lua_GoFishingGetResultWindow:onSureSellFun()
	Lua_ProxyManager.getProxy("Lua_GoFishingProxy"):sDealWithFish(DataCenter.goFishingData.getFish.unique_id, 0, 0);
	self:hide();
end

function Lua_GoFishingGetResultWindow:onSureClick(go)
	local getFish = DataCenter.goFishingData.getFish;
	if self.operateType == 0 or self.operateType == 4 then -- 放入水族馆
		Lua_WindowUtil.openWin("Lua_GoFishingAquariumDetailWindow", Lua_WinParam.ACTION_OPEN, getFish);
	elseif self.operateType == 1 then -- 提交订单，有指定杂物和同种类型杂物两种情况
		Lua_ProxyManager.getProxy("Lua_GoFishingProxy"):sDealWithFish(getFish.unique_id, 2, 0);
		self:hide();
	elseif self.operateType == 2 then -- 出售
		self:onSellFun();
	else -- 放入藏品背包
		Lua_ProxyManager.getProxy("Lua_GoFishingProxy"):sDealWithFish(getFish.unique_id, 3, 0);
		self:hide();
	end
end

function Lua_GoFishingGetResultWindow:dispose()
	if self.fishPropList ~= nil then
		self.fishPropList:dispose();
		self.fishPropList = nil;
	end
	self:superCall("dispose");
end










Lua_GoFishingGetResultItem = class("Lua_GoFishingGetResultItem", Lua_ListCell);
function Lua_GoFishingGetResultItem:ctor(p)
	self:superCall("ctor", p, "GoFishingGetResultItem_skin");
end

function Lua_GoFishingGetResultItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_GoFishingGetResultItem:setData(data)
	if data == nil then
		return;
	end
	self.nameTxt.text = data.show_name;
	self.valueTxt.text = data.showValue;
end

function Lua_GoFishingGetResultItem:dispose()
	self:superCall("dispose");
end