-- 钓鱼-指引界面
Lua_GoFishingGuideWindow = class("Lua_GoFishingGuideWindow", Lua_Window);
function Lua_GoFishingGuideWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_GoFishingGuideWindow";
	self.skinName = "GoFishingGuideWindow_skin";
	self.layer = MainWinDefine.NORMAL_TOP_LAYER;
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_GoFishingGuideWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.desTxt_2:setLangValue(794092);

	self.guideContainer = Lua_DragContainer.new(self.content, 520, 640, Lua_AxisDefine.Vertical);
	self.guideContainer:setCellSpacing(0, 37);
	self.guideContainer:setLocation(0, -135, 0);

	local list = DataCenter.goFishingUtil.fishGuideList;
	self.guideContainer:clearList();
	for i = 1, #list do
		self.guideContainer:addSubContainer(Lua_GoFishingGuideItem, list[i]);
	end
	self.guideContainer:updateChildPos();
	self.guideContainer.canDrag = not self.guideContainer.isTheEnd;
end

function Lua_GoFishingGuideWindow:dispose()
	if self.guideContainer ~= nil then
		self.guideContainer:dispose();
		self.guideContainer = nil;
	end
	self:superCall("dispose");
end










Lua_GoFishingGuideItem = class("Lua_GoFishingGuideItem", Lua_DragContainerItem);
function Lua_GoFishingGuideItem:ctor(p)
	self:superCall("ctor", p, "GoFishingGuideItem_skin");
end

function Lua_GoFishingGuideItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_GoFishingGuideItem:setData(data)
	if data == nil then
		return;
	end

	self.icon:setAltas(data.show_icon[1], data.show_icon[2]);
	self.icon:setScale(data.scale, data.scale);
	self.icon:resetSize();
	self.nameTxt.text = data.name;
	self.desTxt.text = data.des;
	self.desTxt:resetSize();

	local height = 29 + self.desTxt.height;
	local iconHeight = self.icon.height * data.scale;
	self.showHeight = height > iconHeight and height or iconHeight;
	self.line:SetDimensions(2, self.showHeight);
end

function Lua_GoFishingGuideItem:getWidth()
	return 520;
end

function Lua_GoFishingGuideItem:getHeight()
	return self.showHeight;
end

function Lua_GoFishingGuideItem:dispose()
	self:superCall("dispose");
end