-- 钓鱼-鱼饵背包
Lua_GoFishingLureBagWindow = class("Lua_GoFishingLureBagWindow", Lua_Window);
function Lua_GoFishingLureBagWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_GoFishingLureBagWindow";
	self.skinName = "GoFishingLureBagWindow_skin";
	self.layer = MainWinDefine.NORMAL_TOP_LAYER;
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_GoFishingLureBagWindow:buildShowItem()
	self:superCall("buildShowItem");

	local arr = DataCenter.packData:getUnIdList(Lua_PackDefine.GOFISHING, Lua_PackDefine.GOFISHING_LURE);
	arr:add(Lua_ResourcesDefine.ENDLESSLURE); -- 无限鱼饵放最后一个
	self.lureList = Lua_DragList.new(self.content, 616, 746, Lua_AxisDefine.Vertical);
	self.lureList:setListCell(Lua_GoFishingLureBagItem, 196, 259, 3);
	self.lureList:setCellSpacing(14, 15);
	self.lureList:setLocation(0, -33, 0);
	self.lureList:setArrayData(arr);
end

function Lua_GoFishingLureBagWindow:dispose()
	if self.lureList ~= nil then
		self.lureList:dispose();
		self.lureList = nil;
	end
	self:superCall("dispose");
end










Lua_GoFishingLureBagItem = class("Lua_GoFishingLureBagItem", Lua_ListCell);
function Lua_GoFishingLureBagItem:ctor(p)
	self:superCall("ctor", p, "GoFishingLureBagItem_skin");
end

function Lua_GoFishingLureBagItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemIcon = Lua_ItemIcon.new(self.content);
	self.itemIcon:setLocation(0, 31, 0);
end

function Lua_GoFishingLureBagItem:setData(data)
	if data == nil then
		return;
	end

	local numStr;
	if data == Lua_ResourcesDefine.ENDLESSLURE then
		self.tvo = Lua_ToolVo.createToolVo(data);
		numStr = "∞";
	else
		self.tvo = DataCenter.packData:getItemVoByUnId(data);
		numStr = self.tvo.count;
	end
	self.itemIcon:setData(self.tvo);
	self.itemIcon:showText(4, numStr);
	self.nameTxt.text = self.tvo.name;

	if self.tvo.id == DataCenter.goFishingData.lureId then
		self.useTxt:setLangValue(794073);
		self.useTxt.colorStr = Lua_ColorDefine.transColorStr("F3E6BC");
		self.useTxt.effectStyle = 2;
		self.useTxt.effectColorStr = Lua_ColorDefine.transColorStr("896537");
		self.useTxt:setEffectDistance(2, 2);
	else
		self.useTxt:setLangValue(794074);
		self.useTxt.colorStr = Lua_ColorDefine.transColorStr("F8F8EB");
		self.useTxt.effectStyle = 2;
		self.useTxt.effectColorStr = Lua_ColorDefine.transColorStr("97743F");
		self.useTxt:setEffectDistance(2, 2);
	end
end

function Lua_GoFishingLureBagItem:onPressClick()
	local winPos = LuaUtil.getTouchPosInverseObj(self.mainContent);
	if self.itemIcon:checkInBound(winPos.x, winPos.y) then
		self.itemIcon:onItemClick();
	else
		if DataCenter.goFishingData.lureId ~= self.tvo.id then
			OperateAlert.showLangValue(794075);
			Lua_ProxyManager.getProxy("Lua_GoFishingProxy"):sChangeFishingLureId(self.tvo.id);
			Lua_WindowUtil.openWin("Lua_GoFishingLureBagWindow", Lua_WinParam.ACTION_CLOSE);
		end
	end
end

function Lua_GoFishingLureBagItem:dispose()
	if self.itemIcon ~= nil then
		self.itemIcon:dispose();
		self.itemIcon = nil;
	end
	self.tvo = nil;
	self:superCall("dispose");
end