-- 钓鱼-主界面
checkRequire("Lua_GoFishingGearItem");
Lua_GoFishingMainWindow = class("Lua_GoFishingMainWindow", Lua_Window);
function Lua_GoFishingMainWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_GoFishingMainWindow";
	self.skinName = "GoFishingMainWindow_skin";
	self.layer = MainWinDefine.NORMAL_WINDOW_LAYER;
	self.isFullSizeWin = true;
	self.showWinBg = true;
	self.showBackBtn = true;
	self:preLoadWinBg();
end

function Lua_GoFishingMainWindow:preLoadWinBg()
	local fisheryId = DataCenter.goFishingData.fisheryId;
	local config = DataCenter.goFishingUtil:getTheFisheryInfo(fisheryId);
	self.winBgPath = config.main_url;
	self:addPreLoadRes(self.winBgPath, Lua_LoadFileType.IMG);
end

function Lua_GoFishingMainWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.winBg.anchorValue = 4;
	self.winBg.pivotValue = 4;
	self.goFishingTxt:setLangValue(794081);

	self.goFishingBtn:SetDimensions(720, 977 + self.adaptHeight);
	self.goFishingBtn:setLocation(0, 897.5 + self.adaptHeight / 2, 0);
	self.multipleIcon:setEnable(DataCenter.goFishingData.activeUp > 1);

	local mainMoneyItem = DataCenter.goFishingUtil.mainMoneyItem;
	local item;
	self.moneyItemArr = Array();
	for i = 1, #mainMoneyItem do
		item = Lua_MoneyItem.new(self.content);
		item:setRectAnchor(1);
		item:setCanClick(true);
		item:setLocation(439 - i * 190, -24, 0);
		item:setMoney(mainMoneyItem[i]);
		self.moneyItemArr:add(item);
	end

	self.lureItem = Lua_ItemIcon.new(self.uiTweenObj_1);
	self.lureItem:setCanClick(true);
	self.lureItem:setLocation(244, -94.5, 0);

	local gearItem;
	local count = 2;
	self.gearItemArr = Array();
	for i = 1, 4 do
		lineIdx = Mathf.Ceil(i / count);
		columnIdx = i - Mathf.Floor((i - 1) / count) * count;
		posX = -265 + (columnIdx - 1) * 110;
		posY = -66 - (lineIdx - 1) * 110;
		gearItem = Lua_GoFishingGearItem.new(self.uiTweenObj_1);
		gearItem:setCanClick(true);
		gearItem:setScale(0.8, 0.8);
		gearItem:setLocation(posX, posY, 0);
		self.gearItemArr:add(gearItem);
	end

	self.fishGearPropList = Lua_DragList.new(self.uiTweenObj_1, 220, 130, Lua_AxisDefine.Vertical);
	self.fishGearPropList:setListCell(Lua_GoFishingMainFishingGearAttrItem, 220, 31, 1);
	self.fishGearPropList:setLocation(36, -129, 0);

	self.fishIndentList = Lua_DragList.new(self.uiTweenObj_2, 174, 93, Lua_AxisDefine.Vertical);
	self.fishIndentList.canDrag = false;
	self.fishIndentList:setListCell(Lua_GoFishingMainIndentItem, 174, 31, 1);
	self.fishIndentList:setLocation(1.5, 2, 0);

	self.fishClickRedPoint = Lua_RedPointIcon.new(self.content, Lua_RedPointList.GoFishing_CanFishClick);
	-- self.fishClickRedPoint:setRectAnchor(7);
	self.fishClickRedPoint:setLocation(90, -215, 0);

	self.indentRedPoint = Lua_RedPointIcon.new(self.content, Lua_RedPointList.GoFishing_Indent);
	self.indentRedPoint:setRectAnchor(1);
	self.indentRedPoint:setLocation(325, -470, 0);

	self.aquaiumUpLvRedPoint = Lua_RedPointIcon.new(self.content, Lua_RedPointList.GoFishing_AquariumUpLv);
	self.aquaiumUpLvRedPoint:setRectAnchor(7);
	self.aquaiumUpLvRedPoint:setLocation(307, 245, 0);

	self.fisheryRedPoint = Lua_RedPointIcon.new(self.content, Lua_RedPointList.GoFishing_Fishery);
	self.fisheryRedPoint:setRectAnchor(7);
	self.fisheryRedPoint:setLocation(15, 81, 0);

	self.fishgearBg.clickScale = false;
	self.indentBtn.clickScale = false;
	self.ruleBtn_1:addClickFuntion(self, self.onRuleClick_1);
	self.ruleBtn_2:addClickFuntion(self, self.onRuleClick_2);
	self.fishgearBg:addClickFuntion(self, self.onWinBgClick)
	self.detailBtn:addClickFuntion(self, self.onDetailClick);
	self.changeBtn:addClickFuntion(self, self.onChangeClick);
	self.mergeBtn:addClickFuntion(self, self.onMergeClick);
	self.privilegeBtn:addClickFuntion(self, self.onPrivilegeClick);
	self.indentBtn:addClickFuntion(self, self.onIndentClick);
	self.goFishingBtn:addClickFuntion(self, self.onGoFishingClick);
	self.autoBtn:addClickFuntion(self, self.onAutoClick);
	self.fishProtectionBtn:addClickFuntion(self, self.onFishProtectionClick);
	self.aquariumBg:addClickFuntion(self, self.onAquariumClick);
	self.atlasBtn:addClickFuntion(self, self.onAtlasClick);
	self.shopBtn:addClickFuntion(self, self.onShopClick);
	self.dailyGiftBtn:addClickFuntion(self, self.onDailyGiftClick);
	self.rankBtn:addClickFuntion(self, self.onRankClick);

	self:initAnimationInfo();
	self:updateShowInfo();
	self:updateGearAndLureInfo();
	self:updateDailyIndentInfo();
	self:addLuaEvent("PACK_ITEMS_UPDATE", self, self.updateGoFishingItemNum);
	self:addLuaEvent("UPDATE_GOFISHING_INFO", self, self.updateShowInfo);
	self:addLuaEvent("UPDATE_GOFISHING_GEARANDLURE_INFO", self, self.updateGearAndLureInfo);
	self:addLuaEvent("UPDATE_GOFISHING_INDENT_INFO", self, self.updateDailyIndentInfo);
	Lua_ProxyManager.getProxy("Lua_GoFishingProxy"):sGoFishingInfo(1);
end

function Lua_GoFishingMainWindow:onScreenResize()
	self:superCall("onScreenResize");

	self.goFishingBtn:SetDimensions(720, 977 + self.adaptHeight);
	self.goFishingBtn:setLocation(0, 897.5 + self.adaptHeight / 2, 0);
end

function Lua_GoFishingMainWindow:initAnimationInfo()
	self.gofishingEff = UICreate.createUIEffect(self.content, "/effects/uiEffects/cdzj_fish", "cdzj_fish", 243, -490);
	self.gofishingEff.anchorValue = 4;
	self.gofishingEff.siblingIndex = 1;
	self.gofishingEff:setScale(0.9, 0.9);
	DataCenter.goFishingController:addAniSetFun(self, self.onAniSetFun);
	DataCenter.goFishingController:initState();
end

function Lua_GoFishingMainWindow:onAniSetFun(fishingStep, aniName, aniStartTime)
	print("onAniSetFun ", fishingStep, aniName, aniStartTime);
	if fishingStep == 6 then
		OperateAlert.showLangValue(794076);
	elseif fishingStep == 8 then
		if not DataCenter.goFishingController.isAuto and self.isFirstEnter then
			self.fishIcon:setEnable(true);
			Lua_WindowUtil.openWin("Lua_GoFishingGetResultWindow", Lua_WinParam.ACTION_OPEN);
		end
	elseif fishingStep == 9 then
		OperateAlert.showLangValue(794077);
	end
	if fishingStep == 1 or fishingStep == 3 or fishingStep == 8 then
		self.gofishingEff:setSpineAniState(0, aniName, true, 1);
	else
		self.gofishingEff:setSpineAniState(0, aniName, false, 1);
	end
	self.gofishingEff:setSpineAniTime(aniStartTime);
	self.isFirstEnter = true;
end

function Lua_GoFishingMainWindow:updateGoFishingItemNum(dic)
	if dic[DataCenter.goFishingData.lureId] == nil then
		return;
	end
	self:updateLureInfo();
end

function Lua_GoFishingMainWindow:updateLureInfo()
	local lureId = DataCenter.goFishingData.lureId;
	local tvo = Lua_ToolVo.createToolVo(lureId);
	local numStr;
	if lureId == Lua_ResourcesDefine.ENDLESSLURE then
		numStr = "∞";
	else
		numStr = DataCenter.packData:getItemCountById(lureId);
	end
	self.lureItem:setData(tvo);
	self.lureItem:showText(4, numStr);
end

function Lua_GoFishingMainWindow:updateShowInfo()
	local aquariumInfo = DataCenter.goFishingData.aquariumInfo;
	self.aquariumBg:setAltas(aquariumInfo.show_icon[1], aquariumInfo.show_icon[2]);
	self.aquariumTxt.text = LanUtil.formateStr(794078, aquariumInfo.level, aquariumInfo.name);
	self.fishProtectionTxt.text = LanUtil.formateStr(794079, #DataCenter.goFishingData.saveFish, DataCenter.goFishingData.totalfiveSaveNum);

	local getFish = DataCenter.goFishingData.getFish;
	local isAuto = DataCenter.goFishingController.isAuto;
	local isFishing = DataCenter.goFishingController.isFishing;
	if getFish.fishing and getFish.fishing > 0 and not isAuto then
		self.fishIcon:setEnable(true);
		-- self.goFishingTxt:setLangValue(794080);
		self.gofishingEff:setSpineAniState(0, "cdzj_fish_08", true, 1);
	else
		self.fishIcon:setEnable(false);
		-- self.goFishingTxt:setLangValue(794081);
		if not isFishing then -- 还在钓鱼中不处理
			self.gofishingEff:setSpineAniState(0, "cdzj_fish_01", true, 1);
		end
	end
end

function Lua_GoFishingMainWindow:updateGearAndLureInfo()
	local gearInfo, gearRed;
	for i = 1, self.gearItemArr:getSize() do
		gearInfo = DataCenter.goFishingData:getTheFishGearInfo(i);
		if gearInfo then
			self.gearItemArr[i]:setData(gearInfo.gear_id);
		end
		gearRed = DataCenter.goFishingData:getTheFishGearRedInfo(i);
		self.gearItemArr[i]:showRedPoint(gearRed);
	end
	self.fishGearPropList:setArrayData(DataCenter.goFishingData.allGearAttrArr);

	self:updateLureInfo();
end

function Lua_GoFishingMainWindow:updateDailyIndentInfo()
	self.fishIndentList:setArrayData(DataCenter.goFishingData.fishingIndentList);
end

function Lua_GoFishingMainWindow:onBackBtnClick(go)
	local isAuto = DataCenter.goFishingController.isAuto;
	local isFishing = DataCenter.goFishingController.isFishing;
	if not isAuto and isFishing then
		OperateAlert.showLangValue(794082);
		return;
	end
	self:superCall("onBackBtnClick", go);
end

function Lua_GoFishingMainWindow:onRuleClick_1(go)
	Lua_WindowUtil.openWin("Lua_GoFishingRuleWindow", Lua_WinParam.ACTION_OPEN);
end

function Lua_GoFishingMainWindow:onRuleClick_2(go)
	Lua_WindowUtil.openWin("Lua_GoFishingPropDetailWindow", Lua_WinParam.ACTION_OPEN);
end

function Lua_GoFishingMainWindow:onDetailClick(go)
	Lua_WindowUtil.openWin("Lua_GoFishingGearAllAttrWindow", Lua_WinParam.ACTION_OPEN);
end

function Lua_GoFishingMainWindow:onChangeClick(go)
	Lua_WindowUtil.openWin("Lua_GoFishingLureBagWindow", Lua_WinParam.ACTION_OPEN);
end

function Lua_GoFishingMainWindow:onMergeClick(go)
	if not self.isCanMerge then
		self.isCanMerge = true;
		if not self.isMerge then
			TweenUtil.getInstance():addTween(self.mergeBtn.mainContent, 0.6, 0, -10, -60, 0, 0, 0, 90, -1, 1, 1, self, self.onEndMergeTweenFun);
			TweenUtil.getInstance():addTweenTargetPos(self.uiTweenObj_1, 0.6, 0, 0, 250, 0);
			TweenUtil.getInstance():addTweenTargetPos(self.uiTweenObj_2, 0.6, 0, 460, -406, 0);
		else
			TweenUtil.getInstance():addTween(self.mergeBtn.mainContent, 0.6, 0, -10, -299, 0, 0, 0, 90, 1, 1, 1, self, self.onEndMergeTweenFun);
			TweenUtil.getInstance():addTweenTargetPos(self.uiTweenObj_1, 0.6, 0, 0, -59, 0);
			TweenUtil.getInstance():addTweenTargetPos(self.uiTweenObj_2, 0.6, 0, 260.5, -406, 0);
		end
	end
end

function Lua_GoFishingMainWindow:onEndMergeTweenFun()
	self.isCanMerge = false;
	self.isMerge = not self.isMerge;
	TweenUtil.getInstance():stop(self.mergeBtn.mainContent);
	TweenUtil.getInstance():stop(self.uiTweenObj_1);
	TweenUtil.getInstance():stop(self.uiTweenObj_2);
end

function Lua_GoFishingMainWindow:onPrivilegeClick(go)
	DataCenter.funcPathUtil:gotoFunction(1193);
end

function Lua_GoFishingMainWindow:onIndentClick(go)
	Lua_WindowUtil.openWin("Lua_GoFishingDailyIndentWindow", Lua_WinParam.ACTION_OPEN);
end

function Lua_GoFishingMainWindow:onGoFishingClick(go)
	if DataCenter.goFishingController.isFishing then
		OperateAlert.showLangValue(794083);
		return;
	end

	local getFish = DataCenter.goFishingData.getFish;
	if getFish.fishing and getFish.fishing > 0 then
		-- 有未处理的鱼
		Lua_WindowUtil.openWin("Lua_GoFishingGetResultWindow", Lua_WinParam.ACTION_OPEN);
	elseif DataCenter.goFishingData.gofishingOpenTime > 0 then
		local hasCount = DataCenter.packData:getItemCountById(Lua_ResourcesDefine.GOFISHING_STAMINA);
		if hasCount > 0 then
			local saveFish = DataCenter.goFishingData.saveFish;
			if #saveFish > 0 then
				-- 鱼护有鱼要先处理才可以手动，但可以自动
				Lua_WindowUtil.openWin("Lua_GoFishingProtectionWindow", Lua_WinParam.ACTION_OPEN);
			else
				print("手动请求钓鱼");
				DataCenter.goFishingController:playGoFishing(false);
			end
		else
			OperateAlert.showLangValue(794084);
		end
	else
		OperateAlert.showLangValue(794085);
	end
end

function Lua_GoFishingMainWindow:onAutoClick(go)
	if DataCenter.goFishingData.fishTimes >= DataCenter.goFishingUtil.openAutoBtnTimes then
		Lua_WindowUtil.openWin("Lua_GoFishingContractsWindow", Lua_WinParam.ACTION_OPEN);
	else
		OperateAlert.show(LanUtil.formateStr(794086, DataCenter.goFishingUtil.openAutoBtnTimes - DataCenter.goFishingData.fishTimes));
	end	
end

function Lua_GoFishingMainWindow:onFishProtectionClick(go)
	if #DataCenter.goFishingData.saveFish <= 0 then
		OperateAlert.showLangValue(794096);
		return;
	end
	Lua_WindowUtil.openWin("Lua_GoFishingProtectionWindow", Lua_WinParam.ACTION_OPEN);
end

function Lua_GoFishingMainWindow:onAquariumClick(go)
	Lua_WindowUtil.openWin("Lua_GoFishingAquariumWindow", Lua_WinParam.ACTION_OPEN);
end

function Lua_GoFishingMainWindow:onAtlasClick(go)
	Lua_WindowUtil.openWin("Lua_GoFishingAtlasWindow", Lua_WinParam.ACTION_OPEN);
end

function Lua_GoFishingMainWindow:onShopClick(go)
	Lua_WindowUtil.openWin("Lua_GoFishingShopWindow", Lua_WinParam.ACTION_OPEN);
end

function Lua_GoFishingMainWindow:onDailyGiftClick(go)
	Lua_WindowUtil.openWin("Lua_GoFishingDailyGiftWindow", Lua_WinParam.ACTION_OPEN);
end

function Lua_GoFishingMainWindow:onRankClick(go)
	DataCenter.funcPathUtil:gotoFunction(1192);
end

function Lua_GoFishingMainWindow:dispose()
	if self.moneyItemArr ~= nil then
		self.moneyItemArr:dispose();
		self.moneyItemArr:clear();
		self.moneyItemArr = nil;
	end
	if self.lureItem ~= nil then
		self.lureItem:dispose();
		self.lureItem = nil;
	end
	if self.gearItemArr ~= nil then
		self.gearItemArr:dispose();
		self.gearItemArr:clear();
		self.gearItemArr = nil;
	end
	if self.fishGearPropList ~= nil then
		self.fishGearPropList:dispose();
		self.fishGearPropList = nil;
	end
	if self.fishIndentList ~= nil then
		self.fishIndentList:dispose();
		self.fishIndentList = nil;
	end
	if self.gofishingEff ~= nil then
		self.gofishingEff:dispose();
		self.gofishingEff = nil;
	end
	if self.fishClickRedPoint ~= nil then
		self.fishClickRedPoint:dispose();
		self.fishClickRedPoint = nil;
	end
	if self.indentRedPoint ~= nil then
		self.indentRedPoint:dispose();
		self.indentRedPoint = nil;
	end
	if self.aquaiumUpLvRedPoint ~= nil then
		self.aquaiumUpLvRedPoint:dispose();
		self.aquaiumUpLvRedPoint = nil;
	end
	if self.fisheryRedPoint ~= nil then
		self.fisheryRedPoint:dispose();
		self.fisheryRedPoint = nil;
	end
	self:onEndMergeTweenFun();
	DataCenter.goFishingController:removeAniSetFun()
	self:superCall("dispose");
end










Lua_GoFishingMainFishingGearAttrItem = class("Lua_GoFishingMainFishingGearAttrItem", Lua_ListCell);
function Lua_GoFishingMainFishingGearAttrItem:ctor(p)
	self:superCall("ctor", p, "GoFishingMainFishingGearAttrItem_skin");
end

function Lua_GoFishingMainFishingGearAttrItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_GoFishingMainFishingGearAttrItem:setData(data)
	if data == nil then
		return;
	end
	self.nameTxt.text = data.show_name;
	self.valueTxt.text = data.showValue;
end

function Lua_GoFishingMainFishingGearAttrItem:dispose()
	self:superCall("dispose");
end










Lua_GoFishingMainIndentItem = class("Lua_GoFishingMainIndentItem", Lua_ListCell);
function Lua_GoFishingMainIndentItem:ctor(p)
	self:superCall("ctor", p, "GoFishingMainIndentItem_skin");
end

function Lua_GoFishingMainIndentItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_GoFishingMainIndentItem:setData(data)
	local config = DataCenter.goFishingUtil:getFishTaskInfo(data.task_id);
	if data == nil or config == nil then
		return;
	end

	if config.icon ~= nil then
		self.itemIcon:setAltas(config.icon[1], config.icon[2]);
	end
	self.nameTxt.text = config.indent_name;

	local colorStr = data.process >= config.process and "459150" or "F66060";
	local maxColorStr = data.process >= config.process and "459150" or "59626A";
	self.valueTxt.text = LanUtil.formateStr(794087, colorStr, data.process, maxColorStr, config.process);

	self.itemIcon:setEnable(config.icon ~= nil);
	self.nameTxt:setEnable(config.icon == nil);
end

function Lua_GoFishingMainIndentItem:dispose()
	self:superCall("dispose");
end