-- 钓鱼-属性说明
Lua_GoFishingPropDetailWindow = class("Lua_GoFishingPropDetailWindow", Lua_Window);
function Lua_GoFishingPropDetailWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_GoFishingPropDetailWindow";
	self.skinName = "GoFishingPropDetailWindow_skin";
	self.layer = MainWinDefine.NORMAL_TOP_LAYER;
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_GoFishingPropDetailWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.dragContainer = Lua_DragContainer.new(self.content, 480, 756, Lua_AxisDefine.Vertical);
	self.dragContainer:setCellSpacing(0, 15);
	self.dragContainer:setLocation(0, -22, 0);

	local arr = DataCenter.attributesUtil.fishPropArr;
	for i = 1, arr:getSize() do
		self.dragContainer:addSubContainer(Lua_GoFishingPropDetailItem, arr[i]);
	end
	self.dragContainer:updateChildPos();
end

function Lua_GoFishingPropDetailWindow:dispose()
	if self.dragContainer ~= nil then
		self.dragContainer:dispose();
		self.dragContainer = nil;
	end
	self:superCall("dispose");
end










Lua_GoFishingPropDetailItem = class("Lua_GoFishingPropDetailItem", Lua_DragContainerItem);
function Lua_GoFishingPropDetailItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_GoFishingPropDetailItem:buildShowItem()
	self:superCall("buildShowItem");

	self.desTxt = UICreate.createLabel(self.content, nil, 0, 0, 480, 0, 20);
	self.desTxt.anchorValue = 1;
	self.desTxt.pivotValue = 1;
	self.desTxt.alignmentValue = 0;
	-- self.desTxt.fontName = Lua_MyUISettings.huakangFontName;
	self.desTxt.verticalOverflowValue = 1;
end

function Lua_GoFishingPropDetailItem:setData(data)
	if data == nil then
		return;
	end
	self.desTxt.text = getConfig("fishing_prop", data, "overview_des");
	self.desTxt:resetSize();
end

function Lua_GoFishingPropDetailItem:getWidth()
	return self.desTxt.width;
end

function Lua_GoFishingPropDetailItem:getHeight()
	return self.desTxt.height;
end

function Lua_GoFishingPropDetailItem:dispose()
	if self.desTxt ~= nil then
		self.desTxt:dispose();
		self.desTxt = nil;
	end
	self:superCall("dispose");
end