-- 钓鱼-鱼护界面
Lua_GoFishingProtectionWindow = class("Lua_GoFishingProtectionWindow", Lua_Window);
function Lua_GoFishingProtectionWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_GoFishingProtectionWindow";
	self.skinName = "GoFishingProtectionWindow_skin";
	self.layer = MainWinDefine.NORMAL_TOP_LAYER;
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_GoFishingProtectionWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.fishProtectionList = Lua_DragList.new(self.content, 629, 697, Lua_AxisDefine.Vertical);
	self.fishProtectionList:setListCell(Lua_GoFishingProtectionItem, 629, 160, 1);
	self.fishProtectionList:setCellSpacing(0, 10);
	self.fishProtectionList:setLocation(0, -38.5, 0);

	self.sureBtn:addClickFuntion(self, self.onSureClick);

	self:updateFishProtectionInfo()
	self:addLuaEvent("UPDATE_GOFISHING_INFO", self, self.updateFishProtectionInfo);
	self:addLuaEvent("UPDATE_GOFISHING_PROTECTION_SHOWORHIDE", self, self.hide);
end

function Lua_GoFishingProtectionWindow:updateFishProtectionInfo()
	self.fishProtectionList:setArrayData(DataCenter.goFishingData.saveFish);
	self.sureBtn:setBtnEnable(#DataCenter.goFishingData.saveFish > 0);
end

function Lua_GoFishingProtectionWindow:onSureClick(go)
	Lua_ProxyManager.getProxy("Lua_GoFishingProxy"):sFishingProtectionAllComprate();
	self:hide();
end

function Lua_GoFishingProtectionWindow:dispose()
	if self.fishProtectionList ~= nil then
		self.fishProtectionList:dispose();
		self.fishProtectionList = nil;
	end
	self:superCall("dispose");
end










Lua_GoFishingProtectionItem = class("Lua_GoFishingProtectionItem", Lua_ListCell);
function Lua_GoFishingProtectionItem:ctor(p)
	self:superCall("ctor", p, "GoFishingProtectionItem_skin");
end

function Lua_GoFishingProtectionItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemIcon = Lua_ItemIcon.new(self.content);
	self.itemIcon:setSiblingIndex(2);
	self.itemIcon:setLocation(-222, 12, 0);
	self.itemIcon:setScale(0.8, 0.8);
	self.stateBtn:addClickFuntion(self, self.onStateClick);
end

function Lua_GoFishingProtectionItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	local tvo = Lua_ToolVo.createToolVo(data.fishing);
	self.itemIcon:setData(tvo);
	self.nameTxt.text = tvo.colorName;
	local showLength = tvo.max_length > tvo.length * data.length and tvo.length * data.length or tvo.max_length;
	self.lengthTxt.text = string.format("%.2f%s", showLength, "cm");
	self.newGetIcon:setEnable(data.is_new == 2);
	self.newLengthIcon:setEnable(data.is_new == 1 or data.is_new == 2);

	local attrDic = {};
	for k,v in pairs(tvo.add_prop) do
		attrDic[k] = v * data.length;
	end
	local attrArr = DataCenter.attributesUtil:getAttrArrByDic(attrDic);
	local propStr = "";
	for i = 1, attrArr:getSize() do
		propStr = propStr .. attrArr[i].show_name .. attrArr[i].showValue;
		if i ~= attrArr:getSize() then
			propStr = propStr .. "\n";
		end
	end
	self.propTxt.text = propStr;
end

function Lua_GoFishingProtectionItem:onStateClick()
	Lua_WindowUtil.openWin("Lua_GoFishingAquariumDetailWindow", Lua_WinParam.ACTION_OPEN, self._data);
end

function Lua_GoFishingProtectionItem:dispose()
	if self.itemIcon ~= nil then
		self.itemIcon:dispose();
		self.itemIcon = nil;
	end
	self._data = nil;
	self:superCall("dispose");
end