Lua_GoFishingRankRewardWindow = class("Lua_GoFishingRankRewardWindow", Lua_Window)
function Lua_GoFishingRankRewardWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_GoFishingRankRewardWindow";
	self.skinName = "GoFishingRankRewardWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_GoFishingRankRewardWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.btnInfo = Array();
	self.btnInfo:add(540022);
	self.btnInfo:add(540023);

	self.buttonList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Horizontal);
	self.buttonList:setLocation(0, -439, 0);
	self.buttonList:setButtonCell(Lua_CommonButtonItem2);
	self.buttonList:setButtonItem(160, 67);
	self.buttonList:setClickCallBack(self, self.onButtonClick);
	self.buttonList:setData(self.btnInfo);

	self.itemList = Lua_DragList.new(self.content, 630, 635, Lua_AxisDefine.Vertical);
	self.itemList:setLocation(0, -60, 0);
	self.itemList:setListCell(Lua_GoFishingRankRewardItem, 630, 120, 1);
	self.itemList:setCellSpacing(0, 5);
end

function Lua_GoFishingRankRewardWindow:dispose()
	if self.buttonList then
		self.buttonList:dispose();
		self.buttonList = nil;
	end
	if self.btnInfo then
		self.btnInfo:clear();
		self.btnInfo = nil;
	end
	if self.itemList then
		self.itemList:dispose();
		self.itemList = nil;
	end
	self:superCall("dispose");
end

function Lua_GoFishingRankRewardWindow:showWin(param)
	self:superCall("showWin", param);
	if param == 2019 then
		self.buttonList:setSelected(1);
	else
		self.buttonList:setSelected(2);
	end
end

function Lua_GoFishingRankRewardWindow:onButtonClick(index, data)
	local arr = DataCenter.goFishingUtil:getRankRewardList(index);
	self.itemList:setArrayData(arr);
	self.itemList:moveToIndex(1, true);
end










Lua_GoFishingRankRewardItem = class("Lua_GoFishingRankRewardItem", Lua_ListCell)
function Lua_GoFishingRankRewardItem:ctor(p)
	self:superCall("ctor", p, "GoFishingRankRewardItem_skin");
end

function Lua_GoFishingRankRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemList = Lua_ItemIconList.new(self.content);
	self.itemList:setLocation(87, 0, 0);
	self.itemList.scaleVal = 0.75;
end

function Lua_GoFishingRankRewardItem:dispose()
	if self.itemList then
		self.itemList:dispose();
		self.itemList = nil;
	end
	self:superCall("dispose");
end

function Lua_GoFishingRankRewardItem:setData(data)
	local config = getConfig("fishing_rank_reward", data);
	if config.rank[1] <= 3 then
		self.rankIcon:setAltas("common_altas_4", "xui_jys_label_1"..(config.rank[1] - 1));
		self.rankText:setEnable(false);
	else
		self.rankIcon:setAltas("common_altas_4", "xui_jys_label_13");
		self.rankText:setEnable(true);
		self.rankText.fontSize = 30;
		self.rankText.colorStr = Lua_ColorDefine.transColorStr("FFFFFF");
		self.rankText.effectStyle = 2;
		self.rankText.effectColorStr = Lua_ColorDefine.transColor("3E3B44");
		self.rankText:setEffectDistance(2, 2);
		self.rankText:setLocation(-256.5, 1.5, 0);
		if config.rank[1] == config.rank[2] then
			self.rankText.text = config.rank[1];
		else
			self.rankText.text = LanUtil.formateStr(10052, tostring(config.rank[1]), tostring(config.rank[2]));
		end
		self.rankText.fontSize = config.font_size;
	end
	self.itemList:setArrayData(config.rank_reward);
end

function Lua_GoFishingRankRewardItem:onPressClick()
	self.itemList:onBoundClick();
end