-- 钓鱼-玩家介绍界面
Lua_GoFishingRuleWindow = class("Lua_GoFishingRuleWindow", Lua_Window);
function Lua_GoFishingRuleWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_GoFishingRuleWindow";
	self.skinName = "GoFishingRuleWindow_skin";
	self.layer = MainWinDefine.NORMAL_TOP_LAYER;
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_GoFishingRuleWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.dragContainer = Lua_DragContainer.new(self.content, 480, 756, Lua_AxisDefine.Vertical);
	self.dragContainer:setLocation(0, -22, 0);
	self.dragContainer:addSubContainer(Lua_GoFishingRuleItem, LanUtil.getValue(794088), true);
	self.dragContainer.canDrag = not self.dragContainer.isTheEnd;

	self.guideBtn:addClickFuntion(self, self.onGuideClick);
end

function Lua_GoFishingRuleWindow:onGuideClick(go)
	Lua_WindowUtil.openWin("Lua_GoFishingGuideWindow", Lua_WinParam.ACTION_OPEN);
end

function Lua_GoFishingRuleWindow:dispose()
	if self.dragContainer ~= nil then
		self.dragContainer:dispose();
		self.dragContainer = nil;
	end
	self:superCall("dispose");
end










Lua_GoFishingRuleItem = class("Lua_GoFishingRuleItem", Lua_DragContainerItem);
function Lua_GoFishingRuleItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_GoFishingRuleItem:buildShowItem()
	self:superCall("buildShowItem");

	self.desTxt = UICreate.createLabel(self.content, nil, 0, 0, 480, 0, 22);
	self.desTxt.anchorValue = 1;
	self.desTxt.pivotValue = 1;
	self.desTxt.alignmentValue = 0;
	self.desTxt.verticalOverflowValue = 1;
end

function Lua_GoFishingRuleItem:setData(data)
	if data == nil then
		return;
	end
	self.desTxt.text = data;
	self.desTxt:resetSize();
end

function Lua_GoFishingRuleItem:getWidth()
	return self.desTxt.width;
end

function Lua_GoFishingRuleItem:getHeight()
	return self.desTxt.height;
end

function Lua_GoFishingRuleItem:dispose()
	if self.desTxt ~= nil then
		self.desTxt:dispose();
		self.desTxt = nil;
	end
	self:superCall("dispose");
end