-- 钓鱼-水族馆属性总览
Lua_GoFishingAquariumAllAttrWindow = class("Lua_GoFishingAquariumAllAttrWindow", Lua_Window);
function Lua_GoFishingAquariumAllAttrWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_GoFishingAquariumAllAttrWindow";
	self.skinName = "GoFishingAquariumAllAttrWindow_skin";
	self.layer = MainWinDefine.NORMAL_TOP_LAYER;
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_GoFishingAquariumAllAttrWindow:buildShowItem()
	self:superCall("buildShowItem");

	local aquariumList = DataCenter.goFishingData.aquariumList;
	local attrDic = {};
	for i = 1, #aquariumList do
		if aquariumList[i].fish.fishing and aquariumList[i].fish.fishing > 0 then
			tvo = Lua_ToolVo.createToolVo(aquariumList[i].fish.fishing);
			for k,v in pairs(tvo.add_prop) do
				if attrDic[k] == nil then
					attrDic[k] = v * aquariumList[i].fish.length;
				else
					attrDic[k] = attrDic[k] + v * aquariumList[i].fish.length;
				end
			end
		end
	end
	self.attrList = Lua_DragList.new(self.content, 620, 420, Lua_AxisDefine.Vertical);
	self.attrList:setListCell(Lua_GoFishingAquariumAllAttrItem, 620, 39, 1);
	self.attrList:setCellSpacing(0, 5);
	self.attrList:setLocation(0, -20, 0);
	self.attrList:setArrayData(DataCenter.attributesUtil:getAttrArrByDic(attrDic));
end

function Lua_GoFishingAquariumAllAttrWindow:dispose()
	if self.attrList ~= nil then
		self.attrList:dispose();
		self.attrList = nil;
	end
	self:superCall("dispose");
end










Lua_GoFishingAquariumAllAttrItem = class("Lua_GoFishingAquariumAllAttrItem", Lua_ListCell);
function Lua_GoFishingAquariumAllAttrItem:ctor(p)
	self:superCall("ctor", p, "GoFishingAquariumAllAttrItem_skin");
end

function Lua_GoFishingAquariumAllAttrItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_GoFishingAquariumAllAttrItem:setData(data)
	if data == nil then
		return;
	end
	self.nameTxt.text = data.show_name;
	self.valueTxt.text = LanUtil.formateStr(794000, data.showValue);
end

function Lua_GoFishingAquariumAllAttrItem:dispose()
	self:superCall("dispose");
end