-- 钓鱼-水族馆升级界面
Lua_GoFishingAquariumUpWindow = class("Lua_GoFishingAquariumUpWindow", Lua_Window);
function Lua_GoFishingAquariumUpWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_GoFishingAquariumUpWindow";
	self.skinName = "GoFishingAquariumUpWindow_skin";
	self.layer = MainWinDefine.NORMAL_TOP_LAYER;
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_GoFishingAquariumUpWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.progressBar.typeValue = 3;
	self.progressBar.fillMethodValue = 0;
	self.progressBar.fillOrigin = 0;

	self.upList = Lua_DragList.new(self.content, 620, 186, Lua_AxisDefine.Vertical);
	self.upList.canDrag = false;
	self.upList:setListCell(Lua_GoFishingAquariumUpItem, 620, 39, 1);
	self.upList:setCellSpacing(0, 10);
	self.upList:setLocation(0, 52, 0);
	self.upList:setArrayData();

	self.sureBtn:addClickFuntion(self, self.onSureClick);

	self:updateAquariumUpLvInfo();
	self:addLuaEvent("UPDATE_GOFISHING_AQUARIUM_INFO", self, self.updateAquariumUpLvInfo);
end

function Lua_GoFishingAquariumUpWindow:updateAquariumUpLvInfo()
	local aquariumInfo = DataCenter.goFishingData.aquariumInfo;
	self.aquariumIcon:setAltas(aquariumInfo.show_icon[1], aquariumInfo.show_icon[2]);

	local nextAquariumInfo, maxValue, value;
	local aquariumMaxLevel = DataCenter.goFishingUtil.aquariumMaxLevel;
	self.curLvTxt.text = LanUtil.formateStr(794008, aquariumInfo.level);
	if aquariumInfo.level < aquariumMaxLevel - 1 then
		local nextId = (aquariumInfo.level + 1) * 100 + 1;
		nextAquariumInfo = DataCenter.goFishingUtil:getTheAquariumInfo(nextId);
		self.nextLvTxt.text = LanUtil.formateStr(794009, aquariumInfo.level + 1);

		maxValue = DataCenter.goFishingUtil.aquariumStage;
		value = aquariumInfo.step - 1;
	else
		self.nextLvTxt:setLangValue(794010);

		maxValue = DataCenter.goFishingUtil.aquariumStage;
		value = DataCenter.goFishingUtil.aquariumStage;
	end
	self.progressBar:setMaxValue(maxValue);
	self.progressBar:setValue(value);
	self.progressBar:setText(value .. "/" .. maxValue);

	local arr = Array();
	for i = 1, #aquariumInfo.capacity do
		nextNum = 0;
		if nextAquariumInfo then
			nextNum = nextAquariumInfo.capacity[i];
		end
		arr:add{tag = i, curNum = aquariumInfo.capacity[i], nextNum = nextNum};
	end
	self.upList:setArrayData(arr);

	if aquariumInfo.up_cost ~= nil then
		local list = aquariumInfo.up_cost;
		local costStr = "";
		local colorStr, hasCount;
		self.needItemId = nil;
		for i = 1, #list do
			colorStr = "726763";
			hasCount = DataCenter.packData:getItemCountById(list[i][1]);
			if hasCount < list[i][2] then
				colorStr = "E54242";
				if self.needItemId == nil then
					self.needItemId = list[i][1];
				end
			end
			costStr = costStr .. LanUtil.formateStr(794011, spliceIconStrById(list[i][1]), colorStr, hasCount, list[i][2]);
			if i ~= #list then
				costStr = costStr .. " ";
			end
		end
		self.costTxt.text = costStr;
		if self.needItemId then
			self.sureBtn:setLangValue(794012);
		else
			self.sureBtn:setLangValue(794013);
		end
		self.sureBtn:setBtnEnable(true);
	else
		self.costTxt:setEnable(false);
		self.sureBtn:setLangValue(794014);
		self.sureBtn:setBtnEnable(false);
	end
end

function Lua_GoFishingAquariumUpWindow:onSureClick(go)
	if self.needItemId then
		DataCenter.packUtil:openPathWindow(self.needItemId);
	else
		Lua_ProxyManager.getProxy("Lua_GoFishingProxy"):sUpGoFishingAquariumLv();
	end
end

function Lua_GoFishingAquariumUpWindow:dispose()
	if self.upList ~= nil then
		self.upList:dispose();
		self.upList = nil;
	end
	self:superCall("dispose");
end










Lua_GoFishingAquariumUpItem = class("Lua_GoFishingAquariumUpItem", Lua_ListCell);
function Lua_GoFishingAquariumUpItem:ctor(p)
	self:superCall("ctor", p, "GoFishingAquariumUpItem_skin");
end

function Lua_GoFishingAquariumUpItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_GoFishingAquariumUpItem:setData(data)
	if data == nil then
		return;
	end

	local desStr = DataCenter.goFishingUtil:getTheTypeName(data.tag);
	self.curLvValTxt.text = LanUtil.formateStr(794015, desStr, data.curNum);

	local nextNum = data.nextNum <= 0 and data.curNum or data.nextNum;
	local colorStr = nextNum > data.curNum and "479154" or "726763";
	local maxTips = data.nextNum <= 0 and "（Max）" or "";
	self.nextLvValTxt.text = LanUtil.formateStr(794016, colorStr, nextNum, maxTips);
end

function Lua_GoFishingAquariumUpItem:dispose()
	self:superCall("dispose");
end