-- 钓鱼-水族馆主界面
Lua_GoFishingAquariumWindow = class("Lua_GoFishingAquariumWindow", Lua_Window);
function Lua_GoFishingAquariumWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_GoFishingAquariumWindow";
	self.skinName = "GoFishingAquariumWindow_skin";
	self.layer = MainWinDefine.NORMAL_TOP_LAYER;
	self.isFullSizeWin = true;
	self.showBlackMask = true;
	self.showBackBtn = true;
	self.showWinBg = true;
	self.winBgPath = "/images/gofishing/xui_cdzj_bg_10.jpg";
	self:addPreLoadRes(self.winBgPath, Lua_LoadFileType.IMG);
end

function Lua_GoFishingAquariumWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.winBg.anchorValue = 4;
	self.winBg.pivotValue = 4;

	local aquariumMoneyItem = DataCenter.goFishingUtil.aquariumMoneyItem;
	local item;
	self.moneyItemArr = Array();
	for i = 1, #aquariumMoneyItem do
		item = Lua_MoneyItem.new(self.content);
		item:setRectAnchor(1);
		item:setCanClick(true);
		item:setLocation(439 - i * 190, -24, 0);
		item:setMoney(aquariumMoneyItem[i]);
		self.moneyItemArr:add(item);
	end

	self.aquaiumUpLvRedPoint = Lua_RedPointIcon.new(self.content, Lua_RedPointList.GoFishing_AquariumUpLv);
	self.aquaiumUpLvRedPoint:setRectAnchor(7);
	self.aquaiumUpLvRedPoint:setLocation(224, 83, 0);

	self.ruleBtn:addClickFuntion(self, self.onRuleClick);
	self.attrBtn:addClickFuntion(self, self.onAttrClick);
	self.upLvBtn:addClickFuntion(self, self.onUpLvClick);
	self.detailBtn:addClickFuntion(self, self.onDetailClick);

	self:addLuaEvent("UPDATE_GOFISHING_AQUARIUM_INFO", self, self.updateAquariumInfo);
	Lua_ProxyManager.getProxy("Lua_GoFishingProxy"):sGoFishingAquariumInfo();
end

function Lua_GoFishingAquariumWindow:updateAquariumInfo()
	-- 计算鱼的运动
end

function Lua_GoFishingAquariumWindow:onRuleClick(go)
	local tipsData = { des = 794017, posX = -190, posY = -175 };
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
end

function Lua_GoFishingAquariumWindow:onAttrClick(go)
	Lua_WindowUtil.openWin("Lua_GoFishingAquariumAllAttrWindow", Lua_WinParam.ACTION_OPEN);
end

function Lua_GoFishingAquariumWindow:onUpLvClick(go)
	Lua_WindowUtil.openWin("Lua_GoFishingAquariumUpWindow", Lua_WinParam.ACTION_OPEN);
end

function Lua_GoFishingAquariumWindow:onDetailClick(go)
	Lua_WindowUtil.openWin("Lua_GoFishingAquariumDetailWindow", Lua_WinParam.ACTION_OPEN, 0);
end

function Lua_GoFishingAquariumWindow:dispose()
	if self.moneyItemArr ~= nil then
		self.moneyItemArr:dispose();
		self.moneyItemArr:clear();
		self.moneyItemArr = nil;
	end
	if self.aquaiumUpLvRedPoint ~= nil then
		self.aquaiumUpLvRedPoint:dispose();
		self.aquaiumUpLvRedPoint = nil;
	end
	self:superCall("dispose");
end