-- 钓鱼-图鉴属性总览
Lua_GoFishingAtlasAllAttrWindow = class("Lua_GoFishingAtlasAllAttrWindow", Lua_Window);
function Lua_GoFishingAtlasAllAttrWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_GoFishingAtlasAllAttrWindow";
	self.skinName = "GoFishingAtlasAllAttrWindow_skin";
	self.layer = MainWinDefine.NORMAL_TOP_LAYER;
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_GoFishingAtlasAllAttrWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.attrList = Lua_DragList.new(self.content, 620, 420, Lua_AxisDefine.Vertical);
	self.attrList:setListCell(Lua_GoFishingAtlasAllAttrItem, 620, 39, 1);
	self.attrList:setCellSpacing(0, 5);
	self.attrList:setLocation(0, -20, 0);

	self:addLuaEvent("UPDATE_GOFISHING_ATLASATTR_INFO", self, self.updateAtlasAllAttrInfo);
	Lua_ProxyManager.getProxy("Lua_GoFishingProxy"):sGoFishingAtlasAttrInfo();
end

function Lua_GoFishingAtlasAllAttrWindow:updateAtlasAllAttrInfo(msg)
	if msg == nil or #msg == 0 then
		self.attrList:setEnable(false);
	else
		local attrDic = {};
		for i = 1, #msg.book_prop do
			attrDic[msg.book_prop[i].name] = msg.book_prop[i].value;
		end
		local attrArr = DataCenter.attributesUtil:getAttrArrByDic(attrDic);
		self.attrList:setArrayData(attrArr);
		self.attrList:setEnable(true);
	end
end

function Lua_GoFishingAtlasAllAttrWindow:dispose()
	if self.attrList ~= nil then
		self.attrList:dispose();
		self.attrList = nil;
	end
	self:superCall("dispose");
end










Lua_GoFishingAtlasAllAttrItem = class("Lua_GoFishingAtlasAllAttrItem", Lua_ListCell);
function Lua_GoFishingAtlasAllAttrItem:ctor(p)
	self:superCall("ctor", p, "GoFishingAtlasAllAttrItem_skin");
end

function Lua_GoFishingAtlasAllAttrItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_GoFishingAtlasAllAttrItem:setData(data)
	if data == nil then
		return;
	end
	self.nameTxt.text = data.show_name;
	self.valueTxt.text = LanUtil.formateStr(794018, data.showValue);
end

function Lua_GoFishingAtlasAllAttrItem:dispose()
	self:superCall("dispose");
end