-- 钓鱼-全图鉴详情
Lua_GoFishingAtlasDetailWindow = class("Lua_GoFishingAtlasDetailWindow", Lua_Window);
function Lua_GoFishingAtlasDetailWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_GoFishingAtlasDetailWindow";
	self.skinName = "GoFishingAtlasDetailWindow_skin";
	self.layer = MainWinDefine.NORMAL_TOP_LAYER;
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_GoFishingAtlasDetailWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.fishAtlasList = Lua_DragList.new(self.content, 629, 760, Lua_AxisDefine.Vertical);
	self.fishAtlasList:setListCell(Lua_GoFishingAtlasDetailItem, 629, 196, 1);
	self.fishAtlasList:setCellSpacing(0, 6);
	self.fishAtlasList:setLocation(0, -38, 0);

	self:addLuaEvent("UPDATE_GOFISHING_ATLAS_INFO", self, self.updateAtlasDetailInfo);
	self:addLuaEvent("ON_GOFISHING_ATLAS_ITEMCLICK", self, self.onItemPressClick);
end

function Lua_GoFishingAtlasDetailWindow:showWin(param)
	self:superCall("showWin", param);
	self:updateAtlasDetailInfo();
end

function Lua_GoFishingAtlasDetailWindow:updateAtlasDetailInfo(msg)
	if msg == nil or (msg and msg.book_type == self.showData) then
		local arr = DataCenter.goFishingUtil.fishAtlasDic[self.showData];
		self.fishAtlasList:setArrayData(arr);
	end
end

function Lua_GoFishingAtlasDetailWindow:onItemPressClick(param)
	Lua_ProxyManager.getProxy("Lua_GoFishingProxy"):sGoFishingAtlasClick(param.key, self.showData);
end

function Lua_GoFishingAtlasDetailWindow:dispose()
	if self.fishAtlasList ~= nil then
		self.fishAtlasList:dispose();
		self.fishAtlasList = nil;
	end
	self:superCall("dispose");
end










Lua_GoFishingAtlasDetailItem = class("Lua_GoFishingAtlasDetailItem", Lua_ListCell);
function Lua_GoFishingAtlasDetailItem:ctor(p)
	self:superCall("ctor", p, "GoFishingAtlasDetailItem_skin");
end

function Lua_GoFishingAtlasDetailItem:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardList = Lua_DragList.new(self.content, 370, 129, Lua_AxisDefine.Horizontal);
	self.rewardList:setListCell(Lua_GoFishingAtlasDetailItemIcon, 87, 129, 1);
	self.rewardList:setCellSpacing(13, 0);
	self.rewardList:setRectPivot(3);
	self.rewardList:setLocation(-280, -13);
	self:setSubList(self.rewardList);
end

function Lua_GoFishingAtlasDetailItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	local config = DataCenter.goFishingUtil:getFishAtlasInfo(data);
	self.titleTxt.text = config.name;

	local info = DataCenter.goFishingData:getTheFishAtlasInfoById(data);
	local colorStr = "469254";
	for i = 1, #info.book_list do
		if info.book_list[i].other <= 0 then
			colorStr = "726763";
			break;
		end
	end

	local attrArr = DataCenter.attributesUtil:getAttrArrByDic(config.add_prop);
	local desStr = "";
	for i = 1, attrArr:getSize() do
		desStr = desStr .. attrArr[i].show_name .. "+" .. attrArr[i].showValue;
		if i ~= attrArr:getSize() then
			desStr = desStr .. "\n";
		end
	end
	self.attrTxt.text = LanUtil.formateStr(794019, colorStr, desStr);

	self.rewardList.canDrag = #info.book_list > 3;
	self.rewardList:setArrayData(info.book_list);
end

function Lua_GoFishingAtlasDetailItem:dispose()
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	self._data = nil;
	self:superCall("dispose");
end










Lua_GoFishingAtlasDetailItemIcon = class("Lua_GoFishingAtlasDetailItemIcon", Lua_ListCell);
function Lua_GoFishingAtlasDetailItemIcon:ctor(p)
	self:superCall("ctor", p);
end

function Lua_GoFishingAtlasDetailItemIcon:buildShowItem()
	self:superCall("buildShowItem");

	self.itemIcon = Lua_ItemIcon.new(self.content);
	self.itemIcon:setLocation(0, 14.5, 0);
	self.itemIcon:setScale(0.7, 0.7);

	self.newIcon = UICreate.createUIAtlasImage(self.content, "gofishing_atlas_2", "xui_cdzj_label_10", 18, 29, 0, 0);
	self.newIcon:setScale(0.7, 0.7);

	self.nameTxt = UICreate.createLabel(self.content, nil, 0, -53.5, 100, 31, 22);
	self.nameTxt.alignmentValue = 4;
	self.nameTxt.horizontalOverflowValue = 1;
	self.nameTxt.colorStr = Lua_ColorDefine.transColor("726763");
end

function Lua_GoFishingAtlasDetailItemIcon:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	if self.tvo == nil then
		self.tvo = Lua_ToolVo.createToolVo(data.key);
	else
		self.tvo:setData(data.key);
	end
	self.itemIcon:setData(self.tvo);
	self.itemIcon:setMask(data.other <= 0);
	self.nameTxt.text = data.other <= 0 and "？？？" or self.tvo.name;
	self.newIcon:setEnable(data.other > 0 and data.value ~= 1)
end

function Lua_GoFishingAtlasDetailItemIcon:checkInBound(posX, posY)
	local minX = self.centerPosX + self.itemIcon.x - self.itemIcon.itemW * self.itemIcon.scaleX / 2;
	local maxX = self.centerPosX + self.itemIcon.x + self.itemIcon.itemW * self.itemIcon.scaleX / 2;
	local minY = self.centerPosY + self.itemIcon.y - self.itemIcon.itemH * self.itemIcon.scaleY / 2;
	local maxY = self.centerPosY + self.itemIcon.y + self.itemIcon.itemH * self.itemIcon.scaleY / 2;
	return posX >= minX and posX <= maxX and posY >= minY and posY <= maxY;
end

function Lua_GoFishingAtlasDetailItemIcon:onPressClick()
	if self._data.other > 0 and self._data.value ~= 1 then
		Lua_MsgUtil.callFunc("ON_GOFISHING_ATLAS_ITEMCLICK", self._data);
	end
	Lua_WindowUtil.openWin("Lua_GoFishingAtlasSingleDetailWindow", Lua_WinParam.ACTION_OPEN, self._data);
end

function Lua_GoFishingAtlasDetailItemIcon:dispose()
	if self.itemIcon ~= nil then
		self.itemIcon:dispose();
		self.itemIcon = nil;
	end
	if self.newIcon ~= nil then
		self.newIcon:dispose();
		self.newIcon = nil;
	end
	if self.nameTxt ~= nil then
		self.nameTxt:dispose();
		self.nameTxt = nil;
	end
	self._data = nil;
	self.tvo = nil;
	self:superCall("dispose");
end