-- 钓鱼-图鉴界面
Lua_GoFishingAtlasPanel = class("Lua_GoFishingAtlasPanel", Lua_DisplayObject);
function Lua_GoFishingAtlasPanel:ctor(p)
	self:superCall("ctor", p, "GoFishingAtlasPanel_skin");
end

function Lua_GoFishingAtlasPanel:buildShowItem()
	self:superCall("buildShowItem");

	local aquariumInfo = DataCenter.goFishingData.aquariumInfo;
	self.aquariumIcon:setAltas(aquariumInfo.show_icon[1], aquariumInfo.show_icon[2]);
	self.aquariumTxt.text = LanUtil.formateStr(794020, aquariumInfo.level, aquariumInfo.name);

	self.fishAtlasList = Lua_DragList.new(self.content, 687, 1020 + self.adaptHeight, Lua_AxisDefine.Vertical);
	self.fishAtlasList:setListCell(Lua_GoFishingAtlasItem, 687, 342, 1);
	self.fishAtlasList:setCellSpacing(0, 25);
	self.fishAtlasList:setLocation(0, -100, 0);

	self.atlasAttrBtn:addClickFuntion(self, self.onAtlasAttrClick);

	self:updateFishAtlasInfo();
	self:addLuaEvent("UPDATE_GOFISHING_ATLAS_INFO", self, self.updateFishAtlasInfo);
end

function Lua_GoFishingAtlasPanel:onScreenResize(adaptHeight)
	self:superCall("onScreenResize", adaptHeight);

	self.fishAtlasList:setContentRect(687, 1020 + adaptHeight);
end

function Lua_GoFishingAtlasPanel:updateFishAtlasInfo()
	self.fishAtlasList:setArrayData(DataCenter.goFishingUtil.fishAtlasArr);
end

function Lua_GoFishingAtlasPanel:onAtlasAttrClick(go)
	Lua_WindowUtil.openWin("Lua_GoFishingAtlasAllAttrWindow", Lua_WinParam.ACTION_OPEN);
end

function Lua_GoFishingAtlasPanel:dispose()
	if self.fishAtlasList ~= nil then
		self.fishAtlasList:dispose();
		self.fishAtlasList = nil;
	end
	self:superCall("dispose");
end










Lua_GoFishingAtlasItem = class("Lua_GoFishingAtlasItem", Lua_ListCell);
function Lua_GoFishingAtlasItem:ctor(p)
	self:superCall("ctor", p, "GoFishingAtlasItem_skin");
end

function Lua_GoFishingAtlasItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_GoFishingAtlasItem:setData(data)
	self._data = data;
	local info = DataCenter.goFishingData:getTheFishAtlasInfoByType(data);
	if data == nil or info == nil then
		return;
	end

	local unLockNum = DataCenter.goFishingData:getTheFishAtlasUnLockNumByType(data);
	local totalNum = DataCenter.goFishingUtil.fishAtlasDic[data]:getSize();
	self.hasNumTxt.text = LanUtil.formateStr(794021, unLockNum, totalNum);

	local fishAtlasArr = DataCenter.goFishingUtil.fishAtlasArr;
	local arr = DataCenter.goFishingUtil.fishAtlasDic[data];
	local newAtlasRed = false;
	for i = 1, arr:getSize() do
		if DataCenter.goFishingData:getTheNewFishAtlasInfoByType(arr[i]) then
			newAtlasRed = true;
			break;
		end
	end
	self.newIcon:setEnable(newAtlasRed);

	local config = DataCenter.goFishingUtil:getTheFisheryInfo(data);
	self.itemImg:setUrl("/images/gofishing/xui_cdzj_widget_atlas_" .. data ..".png");
	self.nameTxt.text = config and config.name or LanUtil.getValue(794022);

	local collectionUpLvRed = DataCenter.redPointData:getRedPointStateById(Lua_RedPointList.GoFishing_Atlas_Collection);
	self:showRedPoint(collectionUpLvRed and config == nil);
end

function Lua_GoFishingAtlasItem:showRedPoint(bShow)
	if bShow then
		if self.redPointIcon == nil then
			self.redPointIcon = Lua_RedPointIcon.new(self.content);
			self.redPointIcon:setLocation(280, 150);
			self.redPointIcon:createRedPointEff();
		end
		self.redPointIcon:updateRedPointShow(true);
	else
		if self.redPointIcon ~= nil then
			self.redPointIcon:updateRedPointShow(false);
		end
	end
end

function Lua_GoFishingAtlasItem:onPressClick()
	if self._data then
		if self._data == 0 then -- 藏品
			Lua_WindowUtil.openWin("Lua_GoFishingCollectionDetailWindow", Lua_WinParam.ACTION_OPEN, self._data);
		else
			Lua_WindowUtil.openWin("Lua_GoFishingAtlasDetailWindow", Lua_WinParam.ACTION_OPEN, self._data);
		end
	end
end

function Lua_GoFishingAtlasItem:dispose()
	if self.redPointIcon ~= nil then
		self.redPointIcon:dispose();
		self.redPointIcon = nil;
	end
	self._data = nil;
	self:superCall("dispose");
end