-- 钓鱼-单一鱼图鉴详情
Lua_GoFishingAtlasSingleDetailWindow = class("Lua_GoFishingAtlasSingleDetailWindow", Lua_Window);
function Lua_GoFishingAtlasSingleDetailWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_GoFishingAtlasSingleDetailWindow";
	self.skinName = "GoFishingAtlasSingleDetailWindow_skin";
	self.layer = MainWinDefine.NORMAL_TOP_LAYER;
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_GoFishingAtlasSingleDetailWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.itemIcon = Lua_ItemIcon.new(self.content);
	self.itemIcon:setLocation(-213, 177, 0);

	self.outputList = Lua_DragList.new(self.content, 603, 114, Lua_AxisDefine.Vertical);
	self.outputList.canDrag = false;
	self.outputList:setListCell(Lua_GoFishingAtlasSingleDetailItem, 155, 52, 3);
	self.outputList:setCellSpacing(69, 10);
	self.outputList:setLocation(0, -278, 0);
end

function Lua_GoFishingAtlasSingleDetailWindow:showWin(param)
	self:superCall("showWin", param);

	local tvo = Lua_ToolVo.createToolVo(param.key);
	local typeStr = DataCenter.goFishingUtil:getTheTypeName(tvo.sub_type);
	self.itemIcon:setData(tvo);
	self.nameTxt.text = param.other <= 0 and "？？？" or tvo.name;
	self.typeTxt.text = LanUtil.formateStr(794023, typeStr);
	self.desTxt.text = tvo.intro;

	local lengthStr
	if param.other <= 0 then
		lengthStr = "？？？";
	else
		local showLength = tvo.max_length > tvo.length * param.other and tvo.length * param.other or tvo.max_length;
		lengthStr = LanUtil.formateStr(794024, string.format("%.2f%s", showLength, "cm"), tvo.max_length)
	end
	self.lengthTxt.text = lengthStr;

	self.outputList:setArrayData(tvo.fishery_output);
end

function Lua_GoFishingAtlasSingleDetailWindow:dispose()
	if self.itemIcon ~= nil then
		self.itemIcon:dispose();
		self.itemIcon = nil;
	end
	if self.outputList ~= nil then
		self.outputList:dispose();
		self.outputList = nil;
	end
	self:superCall("dispose");
end










Lua_GoFishingAtlasSingleDetailItem = class("Lua_GoFishingAtlasSingleDetailItem", Lua_ListCell);
function Lua_GoFishingAtlasSingleDetailItem:ctor(p)
	self:superCall("ctor", p, "GoFishingAtlasSingleDetailItem_skin");
end

function Lua_GoFishingAtlasSingleDetailItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_GoFishingAtlasSingleDetailItem:setData(data)
	if data == nil then
		return;
	end

	local config = DataCenter.goFishingUtil:getTheFisheryInfo(data);
	self.nameTxt.text = config.name;
end

function Lua_GoFishingAtlasSingleDetailItem:dispose()
	self:superCall("dispose");
end