-- 钓鱼-图鉴界面
checkRequire("Lua_GoFishingFisheryPanel");
checkRequire("Lua_GoFishingAtlasPanel");
Lua_GoFishingAtlasWindow = class("Lua_GoFishingAtlasWindow", Lua_Window);
function Lua_GoFishingAtlasWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_GoFishingAtlasWindow";
	self.skinName = "GoFishingAtlasWindow_skin";
	self.layer = MainWinDefine.NORMAL_TOP_LAYER;
	self.isFullSizeWin = true;
	self.showBlackMask = true;
	self.showBackBtn = true;
	self.showWinBg = true;
	self.winBgPath = "/images/gofishing/xui_cdzj_bg_03.jpg";
	self:addPreLoadRes(self.winBgPath, Lua_LoadFileType.IMG);
end

function Lua_GoFishingAtlasWindow:buildShowItem()
	self:superCall("buildShowItem");

	local arr = Array();
	arr:add({panel = Lua_GoFishingFisheryPanel, textAtlas = "gofishing_atlas", textUnOpenSprite = "xui_cdzj_zgnbutton_1_d", textNormalSprite = "xui_cdzj_zgnbutton_1_n", textSelectedSprite = "xui_cdzj_zgnbutton_1_p", redPointId = Lua_RedPointList.GoFishing_Fishery});
	arr:add({panel = Lua_GoFishingAtlasPanel, textAtlas = "gofishing_atlas", textUnOpenSprite = "xui_cdzj_zgnbutton_2_d", textNormalSprite = "xui_cdzj_zgnbutton_2_n", textSelectedSprite = "xui_cdzj_zgnbutton_2_p", redPointId = Lua_RedPointList.GoFishing_Atlas});
	self.btnList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Horizontal);
	self.btnList.pivot = -1;
	self.btnList:setRectAnchor(8);
	self.btnList:setRectPivot(5);
	self.btnList:setLocation(0, 60.5, 0);
	self.btnList:setButtonStyle("common_altas_1", "xui_common_zgnbutton_07", "xui_common_zgnbutton_07", 118, 118, 0.01, 1);
	self.btnList:setButtonLine("common_altas_1", "xui_common_line_001", 2, 118, 0, 0, 1);
	self.btnList:setButtonItem(120, 118);
	self.btnList:setRedPoint(42, 41);
	self.btnList:setClickCallBack(self, self.onBtnClick);
	self.btnList:setData(arr);
	self.btnList:setSelected(1);

	self.ruleBtn:addClickFuntion(self, self.onRuleClick);

	Lua_ProxyManager.getProxy("Lua_GoFishingProxy"):sGoFishingAllAtlasInfo();
end

function Lua_GoFishingAtlasWindow:onBtnClick(index, data)
	if self.curPanel ~= nil then
		self.curPanel:dispose();
		self.curPanel = nil;
	end
	self.curPanel = data.panel.new(self.content);
	self.curPanel:setRectAnchor(9);
end

function Lua_GoFishingAtlasWindow:onRuleClick(go)
	local tipData = { des = 794025, posX = 185, posY = -180 };
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipData);
end

function Lua_GoFishingAtlasWindow:dispose()
	if self.btnList ~= nil then
		self.btnList:dispose();
		self.btnList = nil;
	end
	if self.curPanel ~= nil then
		self.curPanel:dispose();
		self.curPanel = nil;
	end
	self:superCall("dispose");
end