-- 钓鱼-藏品详情界面
Lua_GoFishingCollectionDetailWindow = class("Lua_GoFishingCollectionDetailWindow", Lua_Window);
function Lua_GoFishingCollectionDetailWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_GoFishingCollectionDetailWindow";
	self.skinName = "GoFishingCollectionDetailWindow_skin";
	self.layer = MainWinDefine.NORMAL_TOP_LAYER;
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_GoFishingCollectionDetailWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.collectionList = Lua_DragList.new(self.content, 629, 760, Lua_AxisDefine.Vertical);
	self.collectionList:setListCell(Lua_GoFishingCollectionDetailItem, 629, 196, 1);
	self.collectionList:setCellSpacing(0, 6);
	self.collectionList:setLocation(0, -38, 0);

	self.bagBtn:addClickFuntion(self, self.onBagLick);

	self:addLuaEvent("UPDATE_GOFISHING_ATLAS_INFO", self, self.updateCollectionDetailInfo);
	self:addLuaEvent("ON_GOFISHING_COLLECTINO_UPLV_ITEMCLICK", self, self.onUpLvItemPressClick);
	self:addLuaEvent("ON_GOFISHING_COLLECTINO_ITEMCLICK", self, self.onItemPressClick);
end

function Lua_GoFishingCollectionDetailWindow:showWin(param)
	self:superCall("showWin", param);
	self:updateCollectionDetailInfo();
end

function Lua_GoFishingCollectionDetailWindow:updateCollectionDetailInfo(msg)
	if msg == nil or (msg and msg.book_type == self.showData) then
		local arr = DataCenter.goFishingUtil.fishAtlasDic[self.showData];
		self.collectionList:setArrayData(arr);
	end
end

function Lua_GoFishingCollectionDetailWindow:onUpLvItemPressClick(param)
	Lua_WindowUtil.openWin("Lua_GoFishingCollectionUpWindow", Lua_WinParam.ACTION_OPEN, {id = param, bookType = self.showData});
end

function Lua_GoFishingCollectionDetailWindow:onItemPressClick(param)
	Lua_ProxyManager.getProxy("Lua_GoFishingProxy"):sGoFishingAtlasClick(param.key, self.showData);
end

function Lua_GoFishingCollectionDetailWindow:onBagLick(go)
	Lua_WindowUtil.openWin("Lua_GoFishingCollectionBagWindow", Lua_WinParam.ACTION_OPEN);
end

function Lua_GoFishingCollectionDetailWindow:dispose()
	if self.collectionList ~= nil then
		self.collectionList:dispose();
		self.collectionList = nil;
	end
	self:superCall("dispose");
end










Lua_GoFishingCollectionDetailItem = class("Lua_GoFishingCollectionDetailItem", Lua_ListCell);
function Lua_GoFishingCollectionDetailItem:ctor(p)
	self:superCall("ctor", p, "GoFishingCollectionDetailItem_skin");
end

function Lua_GoFishingCollectionDetailItem:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardList = Lua_DragList.new(self.content, 370, 129, Lua_AxisDefine.Horizontal);
	self.rewardList:setListCell(Lua_GoFishingCollectionDetailItemIcon, 87, 129, 1);
	self.rewardList:setCellSpacing(13, 0);
	self.rewardList:setRectPivot(3);
	self.rewardList:setLocation(-280, -13);
	self:setSubList(self.rewardList);

	self.stateBtn:addClickFuntion(self, self.onBtnLick);
end

function Lua_GoFishingCollectionDetailItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	local config = DataCenter.goFishingUtil:getFishAtlasInfo(data);
	self.titleTxt.text = config.name;

	local info = DataCenter.goFishingData:getTheFishAtlasInfoById(data);
	local isUnLock = true;
	for i = 1, #info.book_list do
		if info.book_list[i].other <= 0 then
			isUnLock = false;
			break;
		end
	end

	local atlasUpLvId = DataCenter.goFishingUtil:getFishAtlasUpLvId(data, info.level);
	local upLvConfig = DataCenter.goFishingUtil:getFishAtlasUpLvInfo(atlasUpLvId);
	local colorStr = isUnLock and "469254" or "726763";
	local attrDic = DataCenter.attributesUtil:getAttrDic(upLvConfig.add_prop, attrDic);
	if isUnLock then
		attrDic = DataCenter.attributesUtil:getAttrDic(upLvConfig.add_prop, attrDic);
	end
	local attrArr = DataCenter.attributesUtil:getAttrArrByDic(attrDic);
	local desStr = "";
	for i = 1, attrArr:getSize() do
		desStr = desStr .. attrArr[i].show_name .. "+" .. attrArr[i].showValue;
		if i ~= attrArr:getSize() then
			desStr = desStr .. "\n";
		end
	end
	self.attrTxt.text = LanUtil.formateStr(794030, colorStr, desStr);

	self.rewardList.canDrag = #info.book_list > 3;
	self.rewardList:setArrayData(info.book_list);

	self.stateBtn:setBtnEnable(isUnLock);
end

function Lua_GoFishingCollectionDetailItem:onBtnLick(go)
	Lua_MsgUtil.callFunc("ON_GOFISHING_COLLECTINO_UPLV_ITEMCLICK", self._data);
end

function Lua_GoFishingCollectionDetailItem:dispose()
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	self._data = nil;
	self:superCall("dispose");
end










Lua_GoFishingCollectionDetailItemIcon = class("Lua_GoFishingCollectionDetailItemIcon", Lua_ListCell);
function Lua_GoFishingCollectionDetailItemIcon:ctor(p)
	self:superCall("ctor", p);
end

function Lua_GoFishingCollectionDetailItemIcon:buildShowItem()
	self:superCall("buildShowItem");

	self.itemIcon = Lua_ItemIcon.new(self.content);
	self.itemIcon:setLocation(0, 14.5, 0);
	self.itemIcon:setScale(0.7, 0.7);

	self.newIcon = UICreate.createUIAtlasImage(self.content, "gofishing_atlas_2", "xui_cdzj_label_10", 18, 29, 0, 0);
	self.newIcon:setScale(0.7, 0.7);

	self.nameTxt = UICreate.createLabel(self.content, nil, 0, -53.5, 100, 31, 22);
	self.nameTxt.alignmentValue = 4;
	self.nameTxt.horizontalOverflowValue = 1;
	self.nameTxt.colorStr = Lua_ColorDefine.transColor("726763");
end

function Lua_GoFishingCollectionDetailItemIcon:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	if self.tvo == nil then
		self.tvo = Lua_ToolVo.createToolVo(data.key);
	else
		self.tvo:setData(data.key);
	end
	self.itemIcon:setData(self.tvo);
	self.itemIcon:setMask(data.other <= 0);
	self.nameTxt.text = data.other <= 0 and "？？？" or self.tvo.name;
	self.newIcon:setEnable(data.other > 0 and data.value ~= 1)
end

function Lua_GoFishingCollectionDetailItemIcon:checkInBound(posX, posY)
	local minX = self.centerPosX + self.itemIcon.x - self.itemIcon.itemW * self.itemIcon.scaleX / 2;
	local maxX = self.centerPosX + self.itemIcon.x + self.itemIcon.itemW * self.itemIcon.scaleX / 2;
	local minY = self.centerPosY + self.itemIcon.y - self.itemIcon.itemH * self.itemIcon.scaleY / 2;
	local maxY = self.centerPosY + self.itemIcon.y + self.itemIcon.itemH * self.itemIcon.scaleY / 2;
	return posX >= minX and posX <= maxX and posY >= minY and posY <= maxY;
end

function Lua_GoFishingCollectionDetailItemIcon:onPressClick()
	if self._data.other > 0 and self._data.value ~= 1 then
		Lua_MsgUtil.callFunc("ON_GOFISHING_COLLECTINO_ITEMCLICK", self._data);
	end
	Lua_WindowUtil.openWin("Lua_GoFishingCollectionSingleDetailWindow", Lua_WinParam.ACTION_OPEN, self._data);
end

function Lua_GoFishingCollectionDetailItemIcon:dispose()
	if self.itemIcon ~= nil then
		self.itemIcon:dispose();
		self.itemIcon = nil;
	end
	if self.newIcon ~= nil then
		self.newIcon:dispose();
		self.newIcon = nil;
	end
	if self.nameTxt ~= nil then
		self.nameTxt:dispose();
		self.nameTxt = nil;
	end
	self._data = nil;
	self.tvo = nil;
	self:superCall("dispose");
end