-- 钓鱼-单一藏品图鉴详情
Lua_GoFishingCollectionSingleDetailWindow = class("Lua_GoFishingCollectionSingleDetailWindow", Lua_Window);
function Lua_GoFishingCollectionSingleDetailWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_GoFishingCollectionSingleDetailWindow";
	self.skinName = "GoFishingCollectionSingleDetailWindow_skin";
	self.layer = MainWinDefine.NORMAL_TOP_LAYER;
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_GoFishingCollectionSingleDetailWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.itemIcon = Lua_ItemIcon.new(self.content);
	self.itemIcon:setLocation(-213, 177, 0);

	self.outputList = Lua_DragList.new(self.content, 603, 114, Lua_AxisDefine.Vertical);
	self.outputList.canDrag = false;
	self.outputList:setListCell(Lua_GoFishingCollectionSingleDetailItem, 155, 52, 3);
	self.outputList:setCellSpacing(69, 10);
	self.outputList:setLocation(0, -162, 0);
end

function Lua_GoFishingCollectionSingleDetailWindow:showWin(param)
	self:superCall("showWin", param);

	local tvo = Lua_ToolVo.createToolVo(param.key);
	local typeStr = DataCenter.goFishingUtil:getTheTypeName(tvo.sub_type);
	self.itemIcon:setData(tvo);
	self.nameTxt.text = param.other <= 0 and "？？？" or tvo.name;
	self.typeTxt.text = LanUtil.formateStr(794023, typeStr);
	self.desTxt.text = tvo.intro;

	self.outputList:setArrayData(tvo.fishery_output);
end

function Lua_GoFishingCollectionSingleDetailWindow:dispose()
	if self.itemIcon ~= nil then
		self.itemIcon:dispose();
		self.itemIcon = nil;
	end
	if self.outputList ~= nil then
		self.outputList:dispose();
		self.outputList = nil;
	end
	self:superCall("dispose");
end










Lua_GoFishingCollectionSingleDetailItem = class("Lua_GoFishingCollectionSingleDetailItem", Lua_ListCell);
function Lua_GoFishingCollectionSingleDetailItem:ctor(p)
	self:superCall("ctor", p, "GoFishingCollectionSingleDetailItem_skin");
end

function Lua_GoFishingCollectionSingleDetailItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_GoFishingCollectionSingleDetailItem:setData(data)
	if data == nil then
		return;
	end
	local config = DataCenter.goFishingUtil:getTheFisheryInfo(data);
	self.nameTxt.text = config.name;
end

function Lua_GoFishingCollectionSingleDetailItem:dispose()
	self:superCall("dispose");
end