-- 钓鱼-藏品升级成功
Lua_GoFishingCollectionUpLvSucceedWindow = class("Lua_GoFishingCollectionUpLvSucceedWindow", Lua_Window);
function Lua_GoFishingCollectionUpLvSucceedWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_GoFishingCollectionUpLvSucceedWindow";
	self.skinName = "GoFishingCollectionUpLvSucceedWindow_skin";
	self.layer = MainWinDefine.NORMAL_TOP_LAYER;
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_GoFishingCollectionUpLvSucceedWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.maskObj:setPadding(0, 0, 204, 0);

	self.upLvList = Lua_DragList.new(self.content, 720, 125, Lua_AxisDefine.Vertical);
	self.upLvList.canDrag = false;
	self.upLvList:setListCell(Lua_GoFishingCollectionUpLvSucceedItem, 720, 46, 1);
	self.upLvList:setCellSpacing(0, 10);
	self.upLvList:setLocation(0, -20, 0);
end

function Lua_GoFishingCollectionUpLvSucceedWindow:showWin(param)
	self:superCall("showWin", param);

	local atlasUpLvConfig = DataCenter.goFishingUtil:getFishAtlasUpLvInfo(param.book_level);
	local atlasConfig = DataCenter.goFishingUtil:getFishAtlasInfo(atlasUpLvConfig.book);
	local curAttrDic = DataCenter.attributesUtil:getAttrDic(atlasConfig.add_prop);
	curAttrDic = DataCenter.attributesUtil:getAttrDic(atlasUpLvConfig.add_prop, curAttrDic);
	local nextConfig = DataCenter.goFishingUtil:getFishAtlasUpLvInfo(atlasUpLvConfig.next_id);
	local nextAttrDic;
	if nextConfig then
		nextAttrDic = DataCenter.attributesUtil:getAttrDic(nextConfig.add_prop, atlasConfig.add_prop);
		for k,v in pairs(nextConfig.add_prop) do
			if curAttrDic[k] == nil then
				curAttrDic[k] = 0;
			end
		end
	end
	local arr = DataCenter.attributesUtil:getAttrArrByDic(curAttrDic, nextAttrDic);
	self.upLvList:setArrayData(arr);
end

function Lua_GoFishingCollectionUpLvSucceedWindow:dispose()
	if self.upLvList ~= nil then
		self.upLvList:dispose();
		self.upLvList = nil;
	end
	self:superCall("dispose");
end










Lua_GoFishingCollectionUpLvSucceedItem = class("Lua_GoFishingCollectionUpLvSucceedItem", Lua_ListCell);
function Lua_GoFishingCollectionUpLvSucceedItem:ctor(p)
	self:superCall("ctor", p, "GoFishingCollectionUpLvSucceedItem_skin");
end

function Lua_GoFishingCollectionUpLvSucceedItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_GoFishingCollectionUpLvSucceedItem:setData(data)
	if data == nil then
		return;
	end
	self.nameTxt.text = data.show_name;
	self.curLvAttrTxt.text = data.showValue;
	self.nextLvAttrTxt.text = data.nextValue <= 0 and data.showValue .. "(Max)" or data.showNextValue;
end

function Lua_GoFishingCollectionUpLvSucceedItem:dispose()
	self:superCall("dispose");
end