-- 钓鱼-藏品升级
Lua_GoFishingCollectionUpWindow = class("Lua_GoFishingCollectionUpWindow", Lua_Window);
function Lua_GoFishingCollectionUpWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_GoFishingCollectionUpWindow";
	self.skinName = "GoFishingCollectionUpWindow_skin";
	self.layer = MainWinDefine.NORMAL_TOP_LAYER;
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_GoFishingCollectionUpWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.isOnClick = false; -- 点击计时器标识
	self.isOnLongPress = false; -- 是否长按取消

	self.progressBar.typeValue = 3;
	self.progressBar.fillMethodValue = 0;
	self.progressBar.fillOrigin = 0;
	self.progressBar:createSecondBar("common_altas_3","xui_common_tipsprogress_005_f");
	self.progressBar:setSecondValue(1);
	self.progressBar:setValue(0);

	self.fishAtlasList = Lua_DragList.new(self.content, 610, 120, Lua_AxisDefine.Vertical);
	self.fishAtlasList:setListCell(Lua_GoFishingCollectionUpItem, 610, 34, 1);
	self.fishAtlasList:setCellSpacing(0, 6);
	self.fishAtlasList:setLocation(0, 243, 0);

	self.costList = Lua_DragList.new(self.content, 624, 407, Lua_AxisDefine.Vertical);
	self.costList:setListCell(Lua_GoFishingCollectionUpRewardItem, 120, 120, 5);
	self.costList.canLongPress = true;
	self.costList:setCellSpacing(6, 6);
	self.costList:setLocation(0, -106.5);

	self.ruleBtn:addClickFuntion(self, self.onRuleClick);
	self.allBtn:addClickFuntion(self, self.onSelectAllClick);
	self.sureBtn:addClickFuntion(self, self.onSureClick);

	DataCenter.goFishingData.isFirstOpenFishCollection = false;
	DataCenter.redPointData:updateRedPointState(Lua_RedPointList.GoFishing_Atlas_Collection, false);

	self:addLuaEvent("PACK_ITEMS_UPDATE",self, self.updateCollectionUpInfo);
	self:addLuaEvent("ON_GOFISHING_COLLECTNIOUP_MOUSE_UP", self, self.onMouseUpFun); -- 选择材料
	self:addLuaEvent("ON_GOFISHING_COLLECTNIOUP_MOUSE_DOWN", self, self.onMouseDownFun); -- 取消选择材料
	self:addLuaEvent("ON_GOFISHING_COLLECTNIOUP_ITEMCLICK", self, self.updateItemClick); -- 选择材料
	self:addLuaEvent("UPDATE_GOFISHING_ATLAS_INFO", self, self.updateShowInfo); -- 选择材料
end

function Lua_GoFishingCollectionUpWindow:showWin(param)
	self:superCall("showWin", param);
	self:updateShowInfo();
end

function Lua_GoFishingCollectionUpWindow:updateShowInfo()
	local info = DataCenter.goFishingData:getTheFishAtlasInfoById(self.showData.id);
	local atlasUpLvId = DataCenter.goFishingUtil:getFishAtlasUpLvId(self.showData.id, info.level);
	local config = DataCenter.goFishingUtil:getFishAtlasUpLvInfo(atlasUpLvId);
	self.defaultExp = info.exp;
	self.defaultAtlasUpLvId = atlasUpLvId;
	self.isMax = config.next_id == nil; -- 已满级
	self.showExp = info.exp;
	self.endAtlasUpLvId = atlasUpLvId;
	self.selectNumDic = nil; -- id=数量
	if self.isMax then
		self.upLvNeedExp = 0;
	else
		self.upLvNeedExp = config.need_exp - info.exp;
	end
	self:updateCollectionUpInfo();
end

function Lua_GoFishingCollectionUpWindow:updateCollectionUpInfo(dic)
	if dic then
		local main_type, sub_type;
		local isRefresh = false;
		for k,_ in pairs(dic) do
			main_type = getConfig("item", k, "main_type");
			sub_type = getConfig("item", k, "sub_type");
			if main_type == Lua_PackDefine.GOFISHING and sub_type == Lua_PackDefine.GOFISHING_COLLECTION then
				isRefresh = true;
				break;
			end
		end
		if not isRefresh then
			return;
		end
	end

	self.upLvCostArr = DataCenter.goFishingData.upLvCostArr;
	self.costList:setArrayData(self.upLvCostArr);
	self.costList:setEnable(self.upLvCostArr:getSize() > 0);
	-- self:showNone(self.upLvCostArr:getSize() <= 0);
	self:updateProgressInfo();
end

function Lua_GoFishingCollectionUpWindow:updateProgressInfo()
	local atlasUpLvConfig = DataCenter.goFishingUtil:getFishAtlasUpLvInfo(self.endAtlasUpLvId);
	local atlasConfig = DataCenter.goFishingUtil:getFishAtlasInfo(atlasUpLvConfig.book);
	local curAttrDic = DataCenter.attributesUtil:getAttrDic(atlasConfig.add_prop);
	curAttrDic = DataCenter.attributesUtil:getAttrDic(atlasUpLvConfig.add_prop, curAttrDic);
	local nextConfig = DataCenter.goFishingUtil:getFishAtlasUpLvInfo(atlasUpLvConfig.next_id);
	local nextAttrDic;
	if nextConfig and nextConfig.add_prop then
		nextAttrDic = DataCenter.attributesUtil:getAttrDic(nextConfig.add_prop, atlasConfig.add_prop);
		for k,v in pairs(nextAttrDic) do
			if curAttrDic[k] == nil then
				curAttrDic[k] = 0;
			end
		end
	end
	local arr = DataCenter.attributesUtil:getAttrArrByDic(curAttrDic, nextAttrDic);
	self.fishAtlasList:setArrayData(arr);

	if self.isMax then -- 最大等级
		self.progressBar:setSecondMaxValue(1);
		self.progressBar:setSecondValue(1);
		self.progressBar:setMaxValue(1);
		self.progressBar:setValue(0);
		self.progressBar:setText(LanUtil.getValue(794031));
	else
		self.progressBar:setMaxValue(atlasUpLvConfig.need_exp);
		self.progressBar:setSecondMaxValue(atlasUpLvConfig.need_exp);
		self.progressBar:setSecondValue(self.showExp);
		self.progressBar:setText(self.showExp .. "/" .. atlasUpLvConfig.need_exp);
	end
	self.curLvTxt.text = atlasUpLvConfig.level;
	self.nextLvTxt.text = atlasUpLvConfig.next_id and atlasUpLvConfig.level + 1 or LanUtil.getValue(794031);
	self.upTxt.text = LanUtil.formateStr("+{1}", self.selectExp);
	self.upTxt:setEnable(self.selectExp and self.selectExp > 0);
end

function Lua_GoFishingCollectionUpWindow:onMouseUpFun(tvo)
	self:onPress(false, tvo);
end

function Lua_GoFishingCollectionUpWindow:onMouseDownFun(tvo)
	self:onPress(true, tvo);
end

function Lua_GoFishingCollectionUpWindow:onPress(state, tvo)
	self.cancelTvo = tvo;
	if state then
		if self.isOnClick == false then
			self.isOnClick = true;
			self.startClickTime = getTime(); -- 记录开始点击时间
			Lua_CommonUtil.addTimer("Lua_GoFishingCollectionUpWindow", 0.01, self, self.onCancelSelectItem);
		end
	else
		if self.isOnClick == true then
			self.isOnClick = false;
			Lua_CommonUtil.removeTimer(self, self.onCancelSelectItem);
		end
		if self.isOnLongPress == false then
			self:cancelSelectItem(tvo); -- 取消选择材料
		else
			self.isOnLongPress = false;
		end
	end
end

function Lua_GoFishingCollectionUpWindow:onCancelSelectItem()
	if getTime() - self.startClickTime > 0.3 then -- 长按
		self.isOnLongPress = true;
		self:cancelSelectItem(self.cancelTvo);
	end
end

-- 取消材料选择
function Lua_GoFishingCollectionUpWindow:cancelSelectItem(tvo)
	if self.selectNumDic[tvo.tagUid] == 0 then
		return;
	end

	self.selectNumDic[tvo.tagUid] = self.selectNumDic[tvo.tagUid] - 1;
	if self.selectNumDic[tvo.tagUid] <= 0 then
		self.selectNumDic[tvo.tagUid] = nil;
		if self.isOnClick == true then
			self.isOnClick = false;
			Lua_CommonUtil.removeTimer(self,self.onCancelSelectItem);
		end
	end
	self:updateChangeInfo(self.selectNumDic);
end

function Lua_GoFishingCollectionUpWindow:updateChangeInfo(selectNumDic)
	self.selectExp = DataCenter.goFishingData:getExpByCostDic(selectNumDic);
	self.showExp, self.endAtlasUpLvId = DataCenter.goFishingData:getTheEndLevelAndLeftExp(self.defaultExp, self.defaultAtlasUpLvId, self.selectExp);
	self.isMax = false;
	if self.selectExp >= self.upLvNeedExp then -- 选择的经验够升一级
		local config = DataCenter.goFishingUtil:getFishAtlasUpLvInfo(self.endAtlasUpLvId);
		self.isMax = config.next_id == nil;
		self.showExp = self.isMax and config.need_exp or self.showExp;
	else
		self.endAtlasUpLvId = self.defaultAtlasUpLvId;
		self.showExp = self.defaultExp + self.selectExp;
	end
	self:updateShowList();
	self:updateProgressInfo();
end

function Lua_GoFishingCollectionUpWindow:updateShowList()
	if self.costList ~= nil then
		local arr = self.costList.showDragDataList;
		local len = arr:getSize();
		for i = 1, len do
			arr[i].data.selectNum = self.selectNumDic[arr[i].data.tagUid];
			if arr[i].cell ~= nil then
				arr[i].cell:updateBtnState();
			end
		end
	end
end

-- 选择材料更新数据
function Lua_GoFishingCollectionUpWindow:updateItemClick(tvo)
	if self.isMax then -- 最大等级
		OperateAlert.showLangValue(794031);
		return;
	end
	if self.selectNumDic == nil then
		self.selectNumDic = {};
	end
	if self.selectNumDic[tvo.tagUid] == nil then
		self.selectNumDic[tvo.tagUid] = 0;
	end
	if self.selectNumDic[tvo.tagUid] == tvo.count then -- 选择数量到达上限
		OperateAlert.showLangValue(794032);
	else
		self.selectNumDic[tvo.tagUid] = self.selectNumDic[tvo.tagUid] + 1;
		if self.selectNumDic[tvo.tagUid] > tvo.count then -- 选择数量到达上限
			self.selectNumDic[tvo.tagUid] = tvo.count;
		end
		self:updateChangeInfo(self.selectNumDic);
	end
end

function Lua_GoFishingCollectionUpWindow:onRuleClick(go)
	local tipData = { des = 794033, posX = -135, posY = -438 };
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipData);
end

-- 一键添加
function Lua_GoFishingCollectionUpWindow:onSelectAllClick()
	if self.upLvCostArr:getSize() == 0 then -- 没材料
		OperateAlert.showLangValue(794034);
		return;
	end
	if self.isMax then -- 最大等级
		OperateAlert.showLangValue(794035);
		return;
	end
		if self.selectNumDic == nil then
		self.selectNumDic = {};
	end
	local config = DataCenter.goFishingUtil:getFishAtlasUpLvInfo(self.endAtlasUpLvId);
	local needExp = config.need_exp - self.showExp;
	self.selectNumDic = DataCenter.goFishingData:getTheCostInfo(needExp, self.upLvCostArr, self.selectNumDic);
	self:updateChangeInfo(self.selectNumDic);
end

function Lua_GoFishingCollectionUpWindow:onSureClick()
	if self.upLvCostArr:getSize() == 0 then -- 没材料
		-- OperateAlert.showLangValue(794034);
		return;
	end
	if self.isMax then -- 最大等级
		OperateAlert.showLangValue(794035);
		return;
	end

	local isCanUpLv = false;
	if self.selectNumDic == nil then
		OperateAlert.showLangValue(794036);
		return;
	else
		for id, count in pairs(self.selectNumDic) do
			if count > 0 then
				isCanUpLv = true;
				break;
			end
		end
	end
	if not isCanUpLv then
		OperateAlert.showLangValue(794036);
	else
		Lua_ProxyManager.getProxy("Lua_GoFishingProxy"):sUpGoFishingAtlasLv(self.selectNumDic, self.showData.id, self.showData.bookType);
	end
end

function Lua_GoFishingCollectionUpWindow:dispose()
	if self.costList ~= nil then
		self.costList:dispose();
		self.costList = nil;
	end
	self.upLvCostArr = nil;
	self:superCall("dispose");
end










Lua_GoFishingCollectionUpItem = class("Lua_GoFishingCollectionUpItem", Lua_ListCell);
function Lua_GoFishingCollectionUpItem:ctor(p)
	self:superCall("ctor", p, "GoFishingCollectionUpItem_skin");
end

function Lua_GoFishingCollectionUpItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_GoFishingCollectionUpItem:setData(data)
	if data == nil then
		return;
	end
	self.nameTxt.text = data.show_name;
	self.curLvValTxt.text = data.showValue;
	self.nextLvValTxt.text = data.nextValue <= 0 and data.showValue .. "(Max)" or data.showNextValue;
end

function Lua_GoFishingCollectionUpItem:dispose()
	self:superCall("dispose");
end










Lua_GoFishingCollectionUpRewardItem = class("Lua_GoFishingCollectionUpRewardItem", Lua_ListCell);
function Lua_GoFishingCollectionUpRewardItem:ctor(p)
	self:superCall("ctor", p, "GoFishingCollectionUpRewardItem_skin");
end

function Lua_GoFishingCollectionUpRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemIcon = Lua_ItemIcon.new(self.content);
	self.itemIcon:setScale(0.96, 0.96);
	self.itemIcon:setCanClick(false);
	self.itemIcon:setSiblingIndex(0);

	self.changeBtn:setEnable(false);
	self.changeBtn:addMousDownFuntion(self, self.onMouseDownBtn);
	self.changeBtn:addMouseUpFuntion(self, self.onMouseUpBtn);
end

function Lua_GoFishingCollectionUpRewardItem:setData(data)
	self.data = data;
	self.itemIcon:setData(data);
	self.itemIcon:showNum(0);
	self:updateBtnState();
end

-- 更新按钮状态
function Lua_GoFishingCollectionUpRewardItem:updateBtnState()
	-- print("更新按钮状态：", self.data.selectNum)
	local selectNum = self.data.selectNum and self.data.selectNum or 0;
	self.numTxt.text = LanUtil.formateStr(794037, selectNum, self.data.count);
	self.itemIcon:setMask(self.data.selectNum and self.data.selectNum > 0);
	self.changeBtn:setEnable(self.data.selectNum and self.data.selectNum > 0);
end

function Lua_GoFishingCollectionUpRewardItem:onMouseDownBtn()
	Lua_MsgUtil.callFunc("ON_GOFISHING_COLLECTNIOUP_MOUSE_DOWN", self.data);
end

-- 弹起按钮
function Lua_GoFishingCollectionUpRewardItem:onMouseUpBtn()
	Lua_MsgUtil.callFunc("ON_GOFISHING_COLLECTNIOUP_MOUSE_UP", self.data);
end

function Lua_GoFishingCollectionUpRewardItem:onPressClick()
	Lua_MsgUtil.callFunc("ON_GOFISHING_COLLECTNIOUP_ITEMCLICK", self.data);
end

function Lua_GoFishingCollectionUpRewardItem:onLongPressClick()
	self:onPressClick();
end

function Lua_GoFishingCollectionUpRewardItem:dispose()
	if self.itemIcon ~= nil then
		self.itemIcon:dispose();
		self.itemIcon = nil;
	end
	self.data = nil;
	self:superCall("dispose");
end