-- 钓鱼-渔具洗练
checkRequire("Lua_GoFishingGearItem");
Lua_GoFishingGearClearPanel = class("Lua_GoFishingGearClearPanel", Lua_DisplayObject);
function Lua_GoFishingGearClearPanel:ctor(p)
	self:superCall("ctor", p, "GoFishingGearClearPanel_skin");
end

function Lua_GoFishingGearClearPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.gearItem = Lua_GoFishingGearItem.new(self.content);
	self.gearItem:setLocation(0, 206, 0);

	self.clearBox.selected = false;
	self.cancelBtn:addClickFuntion(self, self.onCancelClick);
	self.upBtn:addClickFuntion(self, self.onUpClick);
	self.clearBox:addBoxChange(self, self.onClearBoxChange);

	self:addLuaEvent("UPDATE_GOFISHING_GEARANDLURE_INFO", self, self.updateGearClearInfo);
end

function Lua_GoFishingGearClearPanel:setData(data)
	self._data = data;
	if data == nil then
		return;
	end
	self:updateGearClearInfo();
end

function Lua_GoFishingGearClearPanel:updateGearClearInfo()
	local gearInfo = DataCenter.goFishingData:getTheFishGearInfo(self._data);
	if gearInfo == nil then
		return;
	end

	self.gearConfig = DataCenter.goFishingUtil:getTheFishingGearInfo(gearInfo.gear_id);
	local colorConfig = DataCenter.goFishingUtil:getTheFishingGearColorInfo(self.gearConfig.gear_type * 1000 + self.gearConfig.color);
	self.gearItem:setData(gearInfo.gear_id);
	self.nameTxt.text = Lua_ColorDefine.getColorStr(Lua_ColorDefine.getItemColorStr(self.gearConfig.color), colorConfig.name);
	self.qualityLvTxt.text = LanUtil.formateStr(794039, self.gearConfig.color, self.gearConfig.level);

	local isShowOle = false;
	if gearInfo.prop and #gearInfo.prop > 0 then
		isShowOle = true;
		if self.oleGearPropList == nil then
			self.oleGearPropList = Lua_DragList.new(self.content, 271, 140, Lua_AxisDefine.Vertical);
			self.oleGearPropList:setListCell(Lua_GoFishingOleGearClearItem, 271, 41, 1);
			self.oleGearPropList:setCellSpacing(0, 5);
			self.oleGearPropList:setLocation(-169, -9, 0);
		end
		self.oleGearPropList:setArrayData(gearInfo.prop);
	end
	if self.oleGearPropList then
		self.oleGearPropList:setEnable(isShowOle);
	end

	self.isShowNew = false;
	if gearInfo.brush_prop and #gearInfo.brush_prop > 0 then
		self.isShowNew = true;
		if self.newGearPropList == nil then
			self.newGearPropList = Lua_DragList.new(self.content, 271, 140, Lua_AxisDefine.Vertical);
			self.newGearPropList:setListCell(Lua_GoFishingNewGearClearItem, 271, 41, 1);
			self.newGearPropList:setCellSpacing(0, 5);
			self.newGearPropList:setLocation(169, -9, 0);
		end
		self.newGearPropList:setArrayData(gearInfo.brush_prop);
	end
	if self.newGearPropList then
		self.newGearPropList:setEnable(self.isShowNew);
	end
	self:updateCostInfo();
	self:updateOleNoneInfo(not isShowOle);
	self:updateNewNoneInfo(not self.isShowNew);

	if self.isShowNew then
		self.upBtn:setLangValue(794040);
		self.upBtn:setLocation(168, -196, 0);
		self.cancelBtn:setEnable(true);
	else
		self.upBtn:setLangValue(794041);
		self.upBtn:setLocation(0, -196, 0);
		self.cancelBtn:setEnable(false);
	end
end

function Lua_GoFishingGearClearPanel:updateCostInfo()
	local list;
	if self.clearType then -- 用钻石
		list = self.gearConfig.brush_cost;
	else -- 用道具
		list = self.gearConfig.act_brush_cost;
	end
	local costStr = "";
	local colorStr, hasCount;
	self.needItemId = nil;
	for i = 1, #list do
		colorStr = "755A53";
		hasCount = DataCenter.packData:getItemCountById(list[i][1]);
		if hasCount < list[i][2] then
			colorStr = "D22929";
			if self.needItemId == nil then
				self.needItemId = list[i][1];
			end
		end
		costStr = costStr .. LanUtil.formateStr(794042, spliceIconStrById(list[i][1]), colorStr, hasCount, list[i][2]);
		if i ~= #list then
			costStr = costStr .. " ";
		end
	end
	self.costTxt.text = costStr;
	self.costTxt:setEnable(not self.isShowNew);
end

function Lua_GoFishingGearClearPanel:updateOleNoneInfo(isShow)
	if isShow then
		if self.oleNoneTxt == nil then
			self.oleNoneTxt = UICreate.createLabel(self.content, nil, -169, 10, 100, 31, 24);
			self.oleNoneTxt.alignmentValue = 4;
			self.oleNoneTxt.horizontalOverflowValue = 1;
			self.oleNoneTxt.colorStr = Lua_ColorDefine.transColor("564536");
			self.oleNoneTxt:setLangValue(794043);
		end
		self.oleNoneTxt:setEnable(true);
	else
		if self.oleNoneTxt then
			self.oleNoneTxt:setEnable(false);
		end
	end
end

function Lua_GoFishingGearClearPanel:updateNewNoneInfo(isShow)
	if isShow then
		if self.newNoneTxt == nil then
			self.newNoneTxt = UICreate.createLabel(self.content, nil, 169, 10, 100, 31, 24);
			self.newNoneTxt.alignmentValue = 4;
			self.newNoneTxt.horizontalOverflowValue = 1;
			self.newNoneTxt.colorStr = Lua_ColorDefine.transColor("564536");
			self.newNoneTxt:setLangValue(794043);
		end
		self.newNoneTxt:setEnable(true);
	else
		if self.newNoneTxt then
			self.newNoneTxt:setEnable(false);
		end
	end
end

function Lua_GoFishingGearClearPanel:onCancelClick()
	Lua_ProxyManager.getProxy("Lua_GoFishingProxy"):sSaveClearFishingGearInfo(self.gearConfig.id, 0);
end

function Lua_GoFishingGearClearPanel:onUpClick()
	if self.isShowNew then -- 保存
		Lua_ProxyManager.getProxy("Lua_GoFishingProxy"):sSaveClearFishingGearInfo(self.gearConfig.id, 1);
	else -- 洗练
		if self.needItemId then
			DataCenter.packUtil:openPathWindow(self.needItemId);
		else
			Lua_ProxyManager.getProxy("Lua_GoFishingProxy"):sClearFishingGear(self.gearConfig.id, self.clearType and 2 or 1);
		end
	end
end

function Lua_GoFishingGearClearPanel:onClearBoxChange(val)
	self.clearType = val;
	self:updateCostInfo();
end

function Lua_GoFishingGearClearPanel:dispose()
	if self.gearItem ~= nil then
		self.gearItem:dispose();
		self.gearItem = nil;
	end
	if self.oleGearPropList ~= nil then
		self.oleGearPropList:dispose();
		self.oleGearPropList = nil;
	end
	if self.newGearPropList ~= nil then
		self.newGearPropList:dispose();
		self.newGearPropList = nil;
	end
	if self.oleNoneTxt ~= nil then
		self.oleNoneTxt:dispose();
		self.oleNoneTxt = nil;
	end
	if self.newNoneTxt ~= nil then
		self.newNoneTxt:dispose();
		self.newNoneTxt = nil;
	end
	self.gearConfig = nil;
	self:superCall("dispose");
end










Lua_GoFishingOleGearClearItem = class("Lua_GoFishingOleGearClearItem", Lua_ListCell);
function Lua_GoFishingOleGearClearItem:ctor(p)
	self:superCall("ctor", p, "GoFishingGearClearItem_skin");
end

function Lua_GoFishingOleGearClearItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_GoFishingOleGearClearItem:setData(data)
	self._data = data
	if data == nil then
		return;
	end

	local attrVo = DataCenter.attributesUtil:createAttrVo(data.name);
	if attrVo then
		attrVo.value = data.value;
		self.nameTxt.text = attrVo.show_name;
		self.valueTxt.text = Lua_ColorDefine.getColorStr("564534", attrVo.showValue);
	end
	self.nameTxt:setEnable(attrVo ~= nil);
	self.valueTxt:setEnable(attrVo ~= nil);
end

function Lua_GoFishingOleGearClearItem:dispose()
	self:superCall("dispose");
end










Lua_GoFishingNewGearClearItem = class("Lua_GoFishingNewGearClearItem", Lua_ListCell);
function Lua_GoFishingNewGearClearItem:ctor(p)
	self:superCall("ctor", p, "GoFishingGearClearItem_skin");
end

function Lua_GoFishingNewGearClearItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_GoFishingNewGearClearItem:setData(data)
	self._data = data
	if data == nil then
		return;
	end

	local attrVo = DataCenter.attributesUtil:createAttrVo(data.name);
	if attrVo then
		attrVo.value = data.value;
		self.nameTxt.text = attrVo.show_name;
		self.valueTxt.text = Lua_ColorDefine.getColorStr("439354", attrVo.showValue);
	end
	self.nameTxt:setEnable(attrVo ~= nil);
	self.valueTxt:setEnable(attrVo ~= nil);
end

function Lua_GoFishingNewGearClearItem:dispose()
	self:superCall("dispose");
end