-- 钓鱼-渔具详情
checkRequire("Lua_GoFishingGearItem");
Lua_GoFishingGearDetailWindow = class("Lua_GoFishingGearDetailWindow", Lua_Window);
function Lua_GoFishingGearDetailWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_GoFishingGearDetailWindow";
	self.skinName = "GoFishingGearDetailWindow_skin";
	self.layer = MainWinDefine.NORMAL_TOP_LAYER;
	self.isFullSizeWin = true;
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_GoFishingGearDetailWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.gearItem = Lua_GoFishingGearItem.new(self.content);
	self.gearItem:setLocation(-194, 209, 0);
	self.gearItem:setScale(0.8, 0.8, 0);

	self.fishGearAttrList = Lua_DragList.new(self.content, 456, 190, Lua_AxisDefine.Vertical);
	self.fishGearAttrList:setListCell(Lua_GoFishingGearDetailItem, 456, 31, 1);
	self.fishGearAttrList:setLocation(0, 42, 0);

	self.upBtn:addClickFuntion(self, self.onUpClick);
end

function Lua_GoFishingGearDetailWindow:showWin(param)
	self:superCall("showWin", param);

	local gearConfig = DataCenter.goFishingUtil:getTheFishingGearInfo(param);
	local colorConfig = DataCenter.goFishingUtil:getTheFishingGearColorInfo(gearConfig.gear_type * 1000 + gearConfig.color);
	self.winBg:setAltas("common_altas_2", "xui_common_itembg_"..(gearConfig.color + 6));
	self.gearItem:setData(param);
	self.nameTxt.text = Lua_ColorDefine.getColorStr(Lua_ColorDefine.getItemColorStr(gearConfig.color), colorConfig.name);
	self.qualityLvTxt.text = LanUtil.formateStr(794044, gearConfig.color, gearConfig.level);
	self.desTxt.text = colorConfig.des;

	local gearInfo = DataCenter.goFishingData:getTheFishGearInfo(gearConfig.gear_type);
	local dic = DataCenter.attributesUtil:getAttrDic(gearConfig.base_prop);
	if gearInfo and gearInfo.prop and #gearInfo.prop > 0 then
		local clearAttrDic = {};
		for i = 1, #gearInfo.prop do
			clearAttrDic[gearInfo.prop[i].name] = gearInfo.prop[i].value;
		end
		dic = DataCenter.attributesUtil:getAttrDic(gearConfig.base_prop, clearAttrDic);
	end
	local arr = DataCenter.attributesUtil:getAttrArrByDic(dic);
	self.fishGearAttrList:setArrayData(arr);

	local gearRed = DataCenter.goFishingData:getTheFishGearRedInfo(gearConfig.gear_type);
	self:showRedPoint(gearRed);
end

function Lua_GoFishingGearDetailWindow:showRedPoint(bShow)
	if bShow then
		if self.redPointIcon == nil then
			self.redPointIcon = Lua_RedPointIcon.new(self.content);
			self.redPointIcon:setLocation(63, -162);
			self.redPointIcon:createRedPointEff();
		end
		self.redPointIcon:updateRedPointShow(true);
	else
		if self.redPointIcon ~= nil then
			self.redPointIcon:updateRedPointShow(false);
		end
	end
end

function Lua_GoFishingGearDetailWindow:onUpClick(go)
	Lua_WindowUtil.openWin("Lua_GoFishingGearDevelopWindow", Lua_WinParam.ACTION_OPEN, self.showData);
	self:hide();
end

function Lua_GoFishingGearDetailWindow:dispose()
	if self.fishGearAttrList ~= nil then
		self.fishGearAttrList:dispose();
		self.fishGearAttrList = nil;
	end
	if self.redPointIcon ~= nil then
		self.redPointIcon:dispose();
		self.redPointIcon = nil;
	end
	self:superCall("dispose");
end










Lua_GoFishingGearDetailItem = class("Lua_GoFishingGearDetailItem", Lua_ListCell);
function Lua_GoFishingGearDetailItem:ctor(p)
	self:superCall("ctor", p, "GoFishingGearDetailItem_skin");
end

function Lua_GoFishingGearDetailItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_GoFishingGearDetailItem:setData(data)
	if data == nil then
		return;
	end
	self.nameTxt.text = data.show_name;
	self.valueTxt.text = data.showValue;
end

function Lua_GoFishingGearDetailItem:dispose()
	self:superCall("dispose");
end