-- 钓鱼-渔具培养(升级/洗练)
checkRequire("Lua_GoFishingGearItem");
checkRequire("Lua_GoFishingGearUpPanel");
checkRequire("Lua_GoFishingGearClearPanel");
Lua_GoFishingGearDevelopWindow = class("Lua_GoFishingGearDevelopWindow", Lua_Window);
function Lua_GoFishingGearDevelopWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_GoFishingGearDevelopWindow";
	self.skinName = "GoFishingGearDevelopWindow_skin";
	self.layer = MainWinDefine.NORMAL_TOP_LAYER;
	self.isFullSizeWin = true;
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_GoFishingGearDevelopWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.moneyItemArr = Array();

	local arr = Array();
	arr:add({panel = Lua_GoFishingGearUpPanel, textStr = 794045, redPointId = Lua_RedPointList.GoFishing_Gear_UpLv});
	arr:add({panel = Lua_GoFishingGearClearPanel, textStr = 794046, redPointId = Lua_RedPointList.GoFishing_Gear_Clear});
	self.btnList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Horizontal);
	self.btnList:setButtonStyle("common_altas_1", "xui_common_tab_002", "xui_common_tab_001", 133, 77);
	self.btnList:setButtonText(0, 10, "7A6A5F", "8F5123", 30, 30, Lua_MyUISettings.huakangFontName);
	self.btnList:setRedPoint(45, 15);
	self.btnList:setButtonItem(135, 77);
	self.btnList:setSiblingIndex(0)
	self.btnList:setLocation(0, -550, 0);
	self.btnList:setClickCallBack(self, self.onBtnClick);
	self.btnList:setData(arr);

	local arr = Array();
	for i = 1, 4 do
		arr:add(i);
	end
	self.fishGearAttrList = Lua_DragList.new(self.content, 445, 100, Lua_AxisDefine.Horizontal);
	self.fishGearAttrList:setListCell(Lua_GoFishingGearDevelopItem, 100, 100, 1);
	self.fishGearAttrList:setCellSpacing(15, 0);
	self.fishGearAttrList:setLocation(0, -353, 0);
	self.fishGearAttrList:setArrayData(arr);

	self:addLuaEvent("ON_GEARDEVELOP_ITEM_CLICK", self, self.updateDevelopInfo);
end

function Lua_GoFishingGearDevelopWindow:showWin(param)
	self:superCall("showWin", param);

	local config = DataCenter.goFishingUtil:getTheFishingGearInfo(param);
	self.btnList:setSelected(1);
	self.fishGearAttrList:setSelectClick(config.gear_type);
	self.fishGearAttrList:setSelected(config.gear_type);
end

function Lua_GoFishingGearDevelopWindow:onBtnClick(index, data)
	self.selectIdx = index;
	if self.curPanel ~= nil then
		self.curPanel:dispose();
		self.curPanel = nil;
	end
	self.curPanel = data.panel.new(self.content);
	if self.gearType then
		self:updateDevelopInfo(self.gearType);
	end

	local moneyItem, item;
	if index == 1 then
		moneyItem = DataCenter.goFishingUtil.gearLevelMoneyItem;
	else
		moneyItem = DataCenter.goFishingUtil.gearClearMoneyItem;
	end
	for i = 1, #moneyItem do
		item = self.moneyItemArr[i];
		if item == nil then
			item = Lua_MoneyItem.new(self.content);
			item:setCanClick(true);
			self.moneyItemArr:add(item);
		end
		item:setLocation((i - (#moneyItem + 1) / 2) * 190, 305, 0);
		item:setMoney(moneyItem[i]);
	end
end

function Lua_GoFishingGearDevelopWindow:updateDevelopInfo(gearType)
	self.gearType = gearType;
	if self.selectIdx == 2 then
		self.winBg:SetDimensions(711, 961);
		self.infoBg:setLocation(1, -297, 0);
		self.btnList:setLocation(0, -550, 0);
		self.fishGearAttrList:setLocation(0, -353, 0);
	else
		local gearInfo = DataCenter.goFishingData:getTheFishGearInfo(gearType);
		if gearInfo then
			local gearConfig = DataCenter.goFishingUtil:getTheFishingGearInfo(gearInfo.gear_id);
			if gearConfig.up_task and #gearConfig.up_task > 2 then -- 下面的39和30和升级界面保持一致
				self.winBg:SetDimensions(711, 961 + 39 * (#gearConfig.up_task - 2) + 30);
				self.infoBg:setLocation(1, -297 - 39 * (#gearConfig.up_task - 2) - 30, 0);
				self.btnList:setLocation(0, -550 - 39 * (#gearConfig.up_task - 2) - 30, 0);
				self.fishGearAttrList:setLocation(0, -353 - 39 * (#gearConfig.up_task - 2) - 30, 0);
			else
				self.winBg:SetDimensions(711, 961);
				self.infoBg:setLocation(1, -297, 0);
				self.btnList:setLocation(0, -550, 0);
				self.fishGearAttrList:setLocation(0, -353, 0);
			end
		end
	end
	self.curPanel:setData(gearType);
end

function Lua_GoFishingGearDevelopWindow:dispose()
	if self.moneyItemArr ~= nil then
		self.moneyItemArr:dispose();
		self.moneyItemArr:clear();
		self.moneyItemArr = nil;
	end
	if self.curPanel ~= nil then
		self.curPanel:dispose();
		self.curPanel = nil;
	end
	if self.btnList ~= nil then
		self.btnList:dispose();
		self.btnList = nil;
	end
	if self.fishGearAttrList ~= nil then
		self.fishGearAttrList:dispose();
		self.fishGearAttrList = nil;
	end
	self:superCall("dispose");
end










Lua_GoFishingGearDevelopItem = class("Lua_GoFishingGearDevelopItem", Lua_ListCell);
function Lua_GoFishingGearDevelopItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_GoFishingGearDevelopItem:buildShowItem()
	self:superCall("buildShowItem");

	self.gearItem = Lua_GoFishingGearItem.new(self.content);
	self.gearItem:setScale(0.8, 0.8);
	self.selectIcon = UICreate.createUIAtlasImage(self.content, "online_atlas", "xui_zxjl_widget_4", 0, 0, 0, 0);
	self.selectIcon:setScale(0.8, 0.8);

	self:addLuaEvent("UPDATE_GOFISHING_GEARANDLURE_INFO", self, self.updateDevelopItemInfo);
end

function Lua_GoFishingGearDevelopItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end
	self:updateDevelopItemInfo();
end

function Lua_GoFishingGearDevelopItem:updateDevelopItemInfo()
	local gearInfo = DataCenter.goFishingData:getTheFishGearInfo(self._data);
	if gearInfo then
		self.gearItem:setData(gearInfo.gear_id);
	end
end

function Lua_GoFishingGearDevelopItem:onPressClick()
	if self._data then
		Lua_MsgUtil.callFunc("ON_GEARDEVELOP_ITEM_CLICK", self._data);
		return true;
	end
end

function Lua_GoFishingGearDevelopItem:onSelectionChange(bSelect)
	self:superCall("onSelectionChange", bSelect);
	self.selectIcon:setEnable(bSelect);
end

function Lua_GoFishingGearDevelopItem:dispose()
	if self.gearItem ~= nil then
		self.gearItem:dispose();
		self.gearItem = nil;
	end
	if self.selectIcon ~= nil then
		self.selectIcon:dispose();
		self.selectIcon = nil;
	end
	self:superCall("dispose");
end