-- 钓鱼-渔具item
Lua_GoFishingGearItem = class("Lua_GoFishingGearItem", Lua_DisplayObject);
function Lua_GoFishingGearItem:ctor(p)
	self:superCall("ctor", p, "GoFishingGearItem_skin");
end

function Lua_GoFishingGearItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_GoFishingGearItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	local gearConfig = DataCenter.goFishingUtil:getTheFishingGearInfo(data);
	local colorConfig = DataCenter.goFishingUtil:getTheFishingGearColorInfo(gearConfig.gear_type * 1000 + gearConfig.color);
	local bgAtlas, bgSprite;
	if gearConfig.color == nil then
		bgAtlas = "common_altas_1";
		bgSprite = "xui_common_itembg_0";
	else
		if gearConfig.color == 7 then
			bgAtlas = "common_altas_1";
			bgSprite = "xui_common_itembg_19";
		else
			bgAtlas = "common_altas_1";
			bgSprite = "xui_common_itembg_" .. gearConfig.color;
		end
	end
	self.itemBg:setAltas(bgAtlas, bgSprite);
	self.itemBg:resetSize();
	self.itemIcon:setAltas(colorConfig.icon[1], colorConfig.icon[2]);
	self.itemIcon:resetSize();
	self.levelTxt.text = LanUtil.formateStr(794047, gearConfig.color - 1, gearConfig.level);
end

function Lua_GoFishingGearItem:setShowFishGearLv(bShow)
	self.levelTxt:setEnable(bShow);
end

-- 红点
function Lua_GoFishingGearItem:showRedPoint(bShow)
	if bShow then
		if self.redPointIcon == nil then
			self.redPointIcon = Lua_RedPointIcon.new(self.content);
			self.redPointIcon:setLocation(45, 45);
			self.redPointIcon:createRedPointEff();
		end
		self.redPointIcon:updateRedPointShow(true);
	else
		if self.redPointIcon ~= nil then
			self.redPointIcon:updateRedPointShow(false);
		end
	end
end

function Lua_GoFishingGearItem:setCanClick(bValue)
	if bValue then
		self.itemBg.mouseEnable = true;
		self.itemBg:addClickFuntion(self, self.onItemBgClick);
	else
		self.itemBg.mouseEnable = false;
		self.itemBg:removeClickFuntion(self, self.onItemBgClick);
	end
end

function Lua_GoFishingGearItem:setClick(owner, callBack)
	self.owner = owner;
	self.callBack = callBack;
	if owner == nil or callBack == nil then
		self:setCanClick(false);
	else
		self:setCanClick(true);
	end
end

function Lua_GoFishingGearItem:onItemBgClick(go)
	if self.owner == nil or self.callBack == nil then
		Lua_WindowUtil.openWin("Lua_GoFishingGearDetailWindow", Lua_WinParam.ACTION_OPEN, self._data);
	else
		self.callBack(self.owner, self._data);
	end
end

function Lua_GoFishingGearItem:dispose()
	if self.redPointIcon ~= nil then
		self.redPointIcon:dispose();
		self.redPointIcon = nil;
	end
	self._data = nil;
	self.owner = nil;
	self.callBack = nil;
	self:superCall("dispose");
end