-- 钓鱼-渔具升级
checkRequire("Lua_GoFishingGearItem");
Lua_GoFishingGearUpPanel = class("Lua_GoFishingGearUpPanel", Lua_DisplayObject);
function Lua_GoFishingGearUpPanel:ctor(p)
	self:superCall("ctor", p, "GoFishingGearUpPanel_skin");
end

function Lua_GoFishingGearUpPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.gearItem = Lua_GoFishingGearItem.new(self.content);
	self.gearItem:setLocation(0, 206, 0);
	self.gearUpItem = Lua_GoFishingGearUpItem.new(self.content);
	self.gearUpItem:setLocation(0, 49, 0);

	self.gearTaskContainer = Lua_DragContainer.new(self.upLvObj, 610, 112, Lua_AxisDefine.Vertical);
	self.gearTaskContainer:setCellSpacing(0, 5);
	self.gearTaskContainer:setLocation(0, -105, 0);

	self.upBtn:addClickFuntion(self, self.onUpClick);

	self:addLuaEvent("UPDATE_GOFISHING_GEARANDLURE_INFO", self, self.updateGearUpLvInfo);
end

function Lua_GoFishingGearUpPanel:setData(data)
	self._data = data;
	if data == nil then
		return;
	end
	self:updateGearUpLvInfo();
end

function Lua_GoFishingGearUpPanel:updateGearUpLvInfo()
	local gearInfo = DataCenter.goFishingData:getTheFishGearInfo(self._data);
	if gearInfo == nil then
		return;
	end

	self.gearConfig = DataCenter.goFishingUtil:getTheFishingGearInfo(gearInfo.gear_id);
	local colorConfig = DataCenter.goFishingUtil:getTheFishingGearColorInfo(self.gearConfig.gear_type * 1000 + self.gearConfig.color);
	self.gearItem:setData(gearInfo.gear_id);
	self.nameTxt.text = Lua_ColorDefine.getColorStr(Lua_ColorDefine.getItemColorStr(self.gearConfig.color), colorConfig.name);
	self.qualityLvTxt.text = LanUtil.formateStr(794048, self.gearConfig.color, self.gearConfig.level);

	local dic = self.gearConfig.base_prop;
	local nextDic;
	if self.gearConfig.next_level_id ~= 0 then
		local nextGearConfig = DataCenter.goFishingUtil:getTheFishingGearInfo(self.gearConfig.next_level_id);
		nextDic = nextGearConfig.base_prop;
	end
	local arr = DataCenter.attributesUtil:getAttrArrByDic(dic, nextDic);
	self.gearUpItem:setData(arr[1]);

	local taskInfo;
	local taskCount = #gearInfo.task_state;
	self.isCanAdvanced = true;
	self.gearTaskContainer:clearList();
	for i = 1, #gearInfo.task_state do
		taskInfo = DataCenter.goFishingUtil:getFishTaskInfo(gearInfo.task_state[i].key);
		if self.isCanAdvanced and gearInfo.task_state[i].value < taskInfo.process then
			self.isCanAdvanced = false;
		end
		self.gearTaskContainer:addSubContainer(Lua_GoFishingGearUpTaskItem, gearInfo.task_state[i]);
	end
	self.gearTaskContainer:updateChildPos();
	self.gearTaskContainer.canDrag = not self.gearTaskContainer.isTheEnd;

	local list = self.gearConfig.up_cost;
	local costStr = "";
	local colorStr, hasCount;
	self.needItemId = nil;
	if list then
		for i = 1, #list do
			colorStr = "755A53";
			hasCount = DataCenter.packData:getItemCountById(list[i][1]);
			if hasCount < list[i][2] then
				colorStr = "D22929";
				if self.needItemId == nil then
					self.needItemId = list[i][1];
				end
			end
			costStr = costStr .. LanUtil.formateStr(794049, spliceIconStrById(list[i][1]), colorStr, hasCount, list[i][2]);
			if i ~= #list then
				costStr = costStr .. " ";
			end
		end
	end
	self.costTxt.text = costStr;
	self.costTxt:setEnable(list ~= nil);

	self.progressBar:setMaxValue(self.gearConfig.max_level);
	self.progressBar:setValue(self.gearConfig.level);
	self.progressBar:setText(self.gearConfig.level .. "/" .. self.gearConfig.max_level);

	if self.gearConfig.up_task then
		self.upBtn:setLangValue(794050);
		self.upBtn:setBtnEnable(self.isCanAdvanced);
	else
		self.upBtn:setLangValue(794051);
		self.upBtn:setBtnEnable(true);
	end
	local posY = taskCount > 2 and -(taskCount - 2) * 39 - 30 or 0;
	LuaUtil.setObjPos(self.downObj, 0, posY, 0);
	self.upLvObj:SetActive(self.gearConfig.up_task ~= nil);
	self.progressBar:setEnable(self.gearConfig.next_level_id ~= 0);
	self.upBtn:setEnable(self.gearConfig.next_level_id ~= 0);
	self.maxBg:setEnable(self.gearConfig.next_level_id == 0);
	self.maxTxt:setEnable(self.gearConfig.next_level_id == 0);

	local gearRed = DataCenter.goFishingData:getTheFishGearRedInfo(self.gearConfig.gear_type);
	self:showRedPoint(gearRed);
end

function Lua_GoFishingGearUpPanel:showRedPoint(bShow)
	if bShow then
		if self.redPointIcon == nil then
			self.redPointIcon = Lua_RedPointIcon.new(self.content);
			self.redPointIcon:setLocation(90, -232);
			self.redPointIcon:createRedPointEff();
		end
		self.redPointIcon:updateRedPointShow(true);
	else
		if self.redPointIcon ~= nil then
			self.redPointIcon:updateRedPointShow(false);
		end
	end
end

function Lua_GoFishingGearUpPanel:onUpClick(go)
	if self.gearConfig.up_task then -- 进阶
		if self.isCanAdvanced then
			Lua_ProxyManager.getProxy("Lua_GoFishingProxy"):sUpFishingGearLv(self.gearConfig.id);
		end
	else -- 升级
		if self.needItemId then
			DataCenter.packUtil:openPathWindow(self.needItemId);
		else
			Lua_ProxyManager.getProxy("Lua_GoFishingProxy"):sUpFishingGearLv(self.gearConfig.id);
		end
	end
end

function Lua_GoFishingGearUpPanel:dispose()
	if self.gearItem ~= nil then
		self.gearItem:dispose();
		self.gearItem = nil;
	end
	if self.gearUpItem ~= nil then
		self.gearUpItem:dispose();
		self.gearUpItem = nil;
	end
	if self.gearTaskContainer ~= nil then
		self.gearTaskContainer:dispose();
		self.gearTaskContainer = nil;
	end
	if self.redPointIcon ~= nil then
		self.redPointIcon:dispose();
		self.redPointIcon = nil;
	end
	self.gearConfig = nil;
	self:superCall("dispose");
end










Lua_GoFishingGearUpItem = class("Lua_GoFishingGearUpItem", Lua_ListCell);
function Lua_GoFishingGearUpItem:ctor(p)
	self:superCall("ctor", p, "GoFishingGearUpItem_skin");
end

function Lua_GoFishingGearUpItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_GoFishingGearUpItem:setData(data)
	self._data = data
	if data == nil then
		return;
	end
	self.nameTxt.text = data.show_name;
	self.curLvAttrTxt.text = data.showValue;
	self.nextLvAttrTxt.text = data.showNextValue;
	self.nextLvAttrTxt:setEnable(data.nextValue ~= nil);
end

function Lua_GoFishingGearUpItem:dispose()
	self:superCall("dispose");
end










Lua_GoFishingGearUpTaskItem = class("Lua_GoFishingGearUpTaskItem", Lua_DragContainerItem);
function Lua_GoFishingGearUpTaskItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_GoFishingGearUpTaskItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemBg = UICreate.createUIAtlasImage(self.content, "gofishing_atlas", "xui_fs_widget_08", 0, 0, 610, 34);

	self.taskDesTxt = UICreate.createLabel(self.content, nil, 0, 0, 530, 0, 24);
	self.taskDesTxt.anchorValue = 1;
	self.taskDesTxt.pivotValue = 1;
	self.taskDesTxt.alignmentValue = 0;
	self.taskDesTxt.colorStr = Lua_ColorDefine.transColor("846651");
	self.taskDesTxt.verticalOverflowValue = 1;

	self.targetTxt = UICreate.createLabel(self.content, nil, 0, 0, 530, 0, 24);
	self.targetTxt.anchorValue = 1;
	self.targetTxt.pivotValue = 1;
	self.targetTxt.alignmentValue = 5;
	self.targetTxt.colorStr = Lua_ColorDefine.transColor("9C8472");
	self.targetTxt.verticalOverflowValue = 1;
end

function Lua_GoFishingGearUpTaskItem:setData(data)
	if data == nil then
		return;
	end

	local taskInfo = DataCenter.goFishingUtil:getFishTaskInfo(data.key);
	self.taskDesTxt.text = taskInfo.name;
	self.targetTxt.text = LanUtil.formateStr(794052, data.value, taskInfo.process);
end

function Lua_GoFishingGearUpTaskItem:getWidth()
	return self.itemBg.width;
end

function Lua_GoFishingGearUpTaskItem:getHeight()
	return self.itemBg.height;
end

function Lua_GoFishingGearUpTaskItem:dispose()
	if self.itemBg ~= nil then
		self.itemBg:dispose();
		self.itemBg = nil;
	end
	if self.taskDesTxt ~= nil then
		self.taskDesTxt:dispose();
		self.taskDesTxt = nil;
	end
	if self.targetTxt ~= nil then
		self.targetTxt:dispose();
		self.targetTxt = nil;
	end
	self:superCall("dispose");
end